
/***************************************************\
********                                     ********
********  Schlampisoft X-Window Workbench    ********
********                                     ********
********      (c)1996 by Michael Sohmen      ********
********                                     ********
\***************************************************/

#include <xview/frame.h>
#include <xview/panel.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/scrollbar.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/tty.h>

#include <xview/termsw.h>

#include <xview/cms.h>
#include <xview/xv_xrect.h>
#include <xview/seln.h>
/*#include <xview/sel_pkg.h>*/
#include <xview/notify.h>
#include <xview/file_list.h>

/* The system paths might change ... */

#include <sys/ioctl.h>
#include <errno.h>
#include <signal.h>

/* used for menu_dir function */
#include <sys/stat.h>
#include <dirent.h>
/* #include <sys/dirent.h> */
#ifndef MAXPATHLEN
#include <sys/param.h>
#endif /* MAXPATHLEN */

#ifdef __sun
 #include <unistd.h>
 #include <wchar.h>
 #include <widec.h>
 #include <libintl.h>
 #include <sys/filio.h>

 #include "xwbicons_sun.h"
#else
 #include "xwbicons_linux.h"
#endif

#define NUM_COLORS 16
#define MAXCONFIGS 64 /* MAX + 1 */
#define PATH_TEXT_L 30
#define MAXPROJECTS 256

/*  file */
void New_text_frame ();
void Current_text_frame ();
Menu gen_path_menu ();
Menu Filechoosermenu ();
void Save ();
void Filechooseropen ();
void Filechoosersaveas ();
void Copyright ();
void Save1 ();
void Filechooseropen1 () ;
void configurate      () ;
void Saved_notify     () ;
void proj_Saved_ntfy   () ;
void Quit             () ;
void Quit1            () ;
void Quit2            () ;

/* ttycalls */
void Print     () ;
void Printformat      () ;
void Printformatoddpages  () ;
void Printformatevenpages () ;
void Preformattedprint    () ;
void Compile      () ;
void Compile1      () ;
void RunX         () ;
void RunX1         () ;
void Run          () ;
void Run1          () ;
void Break        () ;
void Break1        () ;

/* periphery */
char *working_directory;
char *file_directory;
int edited=0, projedited[MAXPROJECTS], showbuttons, showtty, compwin_txtsize;

unsigned long 
  horizontalsize, verticalsize, projhorizontalsize, projverticalsize, 
  numberproj, filech_number_rows, help_number_columns, help_number_rows,
  result_number_columns, result_number_rows;
Frame       frame, helpframe, Filech_frame, projframe[MAXPROJECTS], resultframe=0;
Panel       panel, Filech_panel, projpanel[MAXPROJECTS], resultpanel, resultpanel1;
Canvas      canvas ;
Menu        filemenu, toolmenu, optmenu, execmenu, helpmenu,
            textswmenu, compilermenu, terminalmenu, projmenu[MAXPROJECTS] ;
char        filename[512], *filenamep ;
Textsw      textsw, textswproj[MAXPROJECTS] ;
Panel_item  helptext, resulttext ;
unsigned long textsw_buf_size, textsw_proj_buf_size, errmess_buf_size, projitems;

/* Structure for error message evaluation */
struct errorstruct
{
  int first;
  int last;
  int lineno;
  int which_window;
  struct errorstruct *lasterrp;
  struct errorstruct *nexterrp;
} *errorline_pt;

Termsw tty;

/* needed by child process: */

void error_line_number();
int pid, pipe_input[2];
char *comp_results[4096];
int result_counter, comp_mess_count=0;
Notify_client client1 = (Notify_client)10;
/*                         
   parent pipe_input[0]  << [ ][ ] <<  child pipe_input[1]
                                                 */

/* All variables needed by graphic canvas subwindow */
  Cms cms ;

unsigned char red[NUM_COLORS], green[NUM_COLORS], blue[NUM_COLORS] ;
unsigned long  *colors ;
GC  gc ;
Server_image  chips[NUM_COLORS], icon_image ;
Canvas piccanvas ;
char stipple_bits[4];
XID piccanvas_xid ;
XFontStruct *font ;
XGCValues gc_val ;

Xv_Server server ;
Textsw_index cursorpos ;
char *varbuffer;
char *copytext;

char *findstring ;
char *replacestring ;
Display *display ;

Xv_Font textswfont, projtextswfont;
char *spec_font, *spec_font_proj, *saveconfirmation;
int text_fore_color, text_back_color;

Icon icon, compilericon;
int filechooser ;
int Filech_path_text ;
int  compnum, numconfigs ;
void select_conf();
void Showbuttons();
void Showtty();
static void menu_done(), ttysw_menu_done();
Panel_item opt_text, results_message ;
Frame helpframe;

#define BUFFER_UNIT 256

char compilername_buf     [MAXCONFIGS+1][BUFFER_UNIT] ;
char compiler_buf         [MAXCONFIGS+1][BUFFER_UNIT*16] ;
char source_buf           [MAXCONFIGS+1][BUFFER_UNIT] ;
char *current_extension;
char exec_buf             [MAXCONFIGS+1][BUFFER_UNIT] ;
char usew_buf             [MAXCONFIGS+1][BUFFER_UNIT] ;
char printer_buf          [MAXCONFIGS+1][BUFFER_UNIT] ;
char printformat_buf      [MAXCONFIGS+1][BUFFER_UNIT*4] ;
char printformat_even_buf [MAXCONFIGS+1][BUFFER_UNIT*4] ;
char printformat_odd_buf  [MAXCONFIGS+1][BUFFER_UNIT*4] ;
char preformat_print_buf  [MAXCONFIGS+1][BUFFER_UNIT*4] ;
char errmess_buf          [MAXCONFIGS+1][BUFFER_UNIT*4] ;
char term_disable_buf     [MAXCONFIGS+1][BUFFER_UNIT] ;
char help_buf [3][16000] ;
char xpath[1000] ;
Panel_item save_file_text ;
int filecounter, didchangepath, compilerrunning, isreadonly;
unsigned long int path_counter, errpt;
Textsw_status textswstatus;

void textsw_notifyproc    () ;
int  set_file_type        () ;

void Close            () ;
void Cancel_button    () ;
void Linenumber       () ;
void Linenumber1      () ;
void Linenumber2      () ;
void Undo             () ;
void Undoall          () ;
void Redo             () ;
void Find             () ;
void Find1            () ;
void Find2            () ;
void Findnext         () ;
void Findnext1        () ;
void Findnext2        () ;
int  search_string    () ;
void Grep             () ;
void Diff             () ;
void Replace          () ;
void set_replace_string  () ;
void set_replace_string2 () ;
void replace_string   () ;
void Copy_string      () ;
void Copy_string1     () ;
void Copy_string2     () ;
void Cut_string       () ;
void Cut_string1      () ;
void Cut_string2      () ;
void Insert_string    () ;
void Insert_string1    () ;
void Insert_string2    () ;
void Insert_string_in_terminal () ;
void Insert_column      () ;

/* The configuration setup */
void edit_config        () ;
void edit_print_config  () ;
void Set_font           () ;
void save_setup         () ;
Frame Edit_config_frame;
Panel Edit_config_panel;
Panel_item
opt_text_compilername, opt_text_compiler, opt_text_source, opt_text_exec,
opt_text_usew, opt_text_printer, opt_text_printformat, opt_text_printformat_odd,
opt_text_printformat_even, opt_text_preformat_print, opt_text_errmess,
opt_text_term_disable_a, opt_text_term_disable_b;
Panel_item font_foundry, font_weight, font_size, font_for_sw, font_for_projsw;
int set_font_for_sw=1, set_font_for_projsw=0;
int Edit_config_shown=FALSE;
int foundry=3, weight=0, size=3;
Panel_item test_font;

int  filebutton  () ;
int  toolbutton  () ;
int  optbutton   () ;
int  execbutton  () ; 
int  helpbutton  () ;          
void Helpabout    () ;
void Helpquick    () ;
void Helpdetail   () ;
void WWW_Home     () ;

void canvas_repaint () ;
void piccanvas_repaint () ;
void initcolor    () ;
void initchips    () ;
void choosecolor  () ; 
void cancel_quit  () ;
void evaluate_errmess();
Notify_value notify_resize () ;

char *Create_string() ;
void getselectionproc() ;

Panel button_panel;
Panel_item savebutton, saveprojbutton[MAXPROJECTS], compilebutton1, compilebutton2, 
           runbutton1, runbutton2,
           runXbutton1, runXbutton2, closebutton,
           next_errbutton, first_errbutton, prev_errbutton, last_errbutton,
           saveprojbutton[MAXPROJECTS];

Textsw_index first, last;  /* search */

/* timer for animation */
struct itimerval  timer;

FILE *fp;

main (argc, argv)
int argc ; 
char *argv[] ;
{
  int i;
  char *tmpstring;
  
  /* read in config file and get current path */
  configurate(CONFIG_FILE);
  working_directory = Create_string(getcwd(NULL, MAXPATHLEN));
  file_directory = Create_string(getcwd(NULL, MAXPATHLEN));
  
  opt_text=0;
  
  /* Some necessary pre-allocating */
  
  findstring = malloc(2);      sprintf(findstring, "");
  copytext   = malloc(2);      sprintf(copytext, "");
  varbuffer  = malloc(2);      sprintf(varbuffer, "");

  errorline_pt=malloc(sizeof(struct errorstruct));
  errorline_pt->lasterrp=NULL;
  errorline_pt->nexterrp=NULL;
  for (i=0; i<MAXPROJECTS; i++)
    projframe[i]=0;
  comp_results[0]=NULL;

  /* start X-Window process */
  xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

  /* creation of icons */
  icon = (Icon)xv_create(frame, ICON,
      ICON_IMAGE,         
          (Server_image)xv_create((int)NULL, SERVER_IMAGE,
              XV_WIDTH,           64,
              XV_HEIGHT,          64,
              SERVER_IMAGE_BITS,  xwbicon_bits,
              NULL),
      XV_X,               100,
      XV_Y,               100,
      NULL);
  compilericon = (Icon)xv_create(frame, ICON,
      ICON_IMAGE,         
          (Server_image)xv_create((int)NULL, SERVER_IMAGE,
              XV_WIDTH,        64,
              XV_HEIGHT,       64,
              SERVER_IMAGE_BITS,         compiler_bits,
              NULL),
      XV_X,               100,
      XV_Y,               100,
      NULL);

  /* Initialize Colors */
  initcolor(cms, red, green, blue);
  /*initchips(panel, chips) ;*/
  compnum=0 ;
  stipple_bits[0] = 0xAA ; stipple_bits[1] = 0xAA ;
  stipple_bits[2] = 0x55 ; stipple_bits[3] = 0x55 ;
  
  /* Initialize  base frame */
  frame = (Frame)xv_create ((int)NULL, FRAME, 
       FRAME_LABEL,     "Schlampisoft X-Window Workbench",
       XV_WIDTH,        horizontalsize,
       XV_HEIGHT,       verticalsize,
       FRAME_ICON,      icon,
       NULL) ;
  display = (Display *)xv_get (frame, XV_DISPLAY);

  /* Initialize menu */
  filemenu = (Menu) xv_create((int)NULL , MENU,             
       MENU_ITEM,
         MENU_STRING,        "New frame", 
         MENU_NOTIFY_PROC,    New_text_frame,
         MENU_CLIENT_DATA,    argv[0],
         NULL,
       MENU_ITEM,
         MENU_STRING,        "Clear window", 
         MENU_NOTIFY_PROC,    Current_text_frame,
         NULL,
       MENU_ITEM,
         MENU_STRING,       "Open",
         MENU_NOTIFY_PROC,   Filechooseropen,
         NULL,   
       MENU_ITEM,
         MENU_STRING,        "Save",
         MENU_NOTIFY_PROC,    Save, 
         NULL,
       MENU_ITEM,
         MENU_STRING,       "Save as",
         MENU_NOTIFY_PROC,   Filechoosersaveas,
         NULL,   
       MENU_ITEM,
         MENU_STRING,      "Print",
         MENU_NOTIFY_PROC,  Print,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Formatted print",
         MENU_PULLRIGHT,
         xv_create(panel, MENU,
           MENU_ITEM,
             MENU_STRING,       "Print preformatted",
             MENU_NOTIFY_PROC,  Preformattedprint,
             NULL,
           MENU_ITEM,
             MENU_STRING,       "Print all",
             MENU_NOTIFY_PROC,  Printformat,
             NULL,
           MENU_ITEM,
             MENU_STRING,       "Print odd pages",
             MENU_NOTIFY_PROC,  Printformatoddpages,
             NULL,
           MENU_ITEM,
             MENU_STRING,       "Print even pages",
             MENU_NOTIFY_PROC,  Printformatevenpages,
             NULL,
           NULL),
         NULL,
       MENU_ITEM,
         MENU_STRING,      "QUIT",
         MENU_NOTIFY_PROC,  Quit,            
         NULL,
       NULL);
  toolmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_ITEM,
         MENU_STRING,      "Line number",
         MENU_NOTIFY_PROC,  Linenumber,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Undo all",
         MENU_NOTIFY_PROC,  Undoall,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Undo",
         MENU_NOTIFY_PROC,  Undo,
         NULL,
       /*MENU_ITEM,
         MENU_STRING,      "Redo",
         PANEL_INACTIVE,    TRUE,
         MENU_NOTIFY_PROC,  Redo,
         NULL,*/
       MENU_ITEM,  
         MENU_STRING,         "Find",
         MENU_PULLRIGHT,
         xv_create(panel ,     MENU,
           MENU_ITEM,
             MENU_STRING,        "searching forward", 
             MENU_CLIENT_DATA,    0,
            MENU_NOTIFY_PROC,     Find,
             NULL,
           MENU_ITEM,
             MENU_STRING,        "searching backward", 
             MENU_CLIENT_DATA,    1,
            MENU_NOTIFY_PROC,     Find,
             NULL,
           NULL),
         NULL,
       MENU_ITEM,  
         MENU_STRING,         "Find next",
         MENU_PULLRIGHT,
         xv_create(panel ,     MENU,
           MENU_ITEM,
             MENU_STRING,        "searching forward", 
             MENU_CLIENT_DATA,    0,
            MENU_NOTIFY_PROC,     Findnext,
             NULL,
           MENU_ITEM,
             MENU_STRING,        "searching backward", 
             MENU_CLIENT_DATA,    1,
            MENU_NOTIFY_PROC,     Findnext,
             NULL,
           NULL),
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Replace",
         MENU_NOTIFY_PROC,  Replace,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Special",
         MENU_PULLRIGHT,
         xv_create(panel,   MENU,
         MENU_ITEM,
           MENU_STRING,      "Column add/del",
           MENU_NOTIFY_PROC,  Insert_column, 
           NULL,
         MENU_ITEM,
           MENU_STRING,      "Grep",
           MENU_NOTIFY_PROC,  Grep,
           NULL,
         MENU_ITEM,
           MENU_STRING,      "Diff",
           MENU_NOTIFY_PROC,  Diff,
           NULL,
         NULL),
       NULL,
       MENU_ITEM,
         MENU_STRING,      "Cut string",
         MENU_NOTIFY_PROC,  Cut_string, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Copy string",
         MENU_NOTIFY_PROC,  Copy_string, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Insert string",
         MENU_NOTIFY_PROC,  Insert_string, 
         NULL,
       NULL);
  optmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_ITEM,
         MENU_STRING,      "Hide/show",
         MENU_PULLRIGHT,
         xv_create(panel,   MENU,
           MENU_ITEM,
           MENU_STRING,      "Left button panel",
           MENU_NOTIFY_PROC,  Showbuttons, 
           NULL,
         MENU_ITEM,
           MENU_STRING,      "Bottom terminal",
           MENU_NOTIFY_PROC,  Showtty, 
           NULL,
           NULL),
       NULL,
       MENU_ITEM,
         MENU_STRING,      "Choose configuration",
         MENU_PULLRIGHT,
         xv_create(panel,   MENU,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[0],
             MENU_CLIENT_DATA,  0,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[1],
             MENU_CLIENT_DATA,  1,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[2],
             MENU_CLIENT_DATA,  2,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[3],
             MENU_CLIENT_DATA,  3,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[4],
             MENU_CLIENT_DATA,  4,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[5],
             MENU_CLIENT_DATA,  5,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[6],
             MENU_CLIENT_DATA,  6,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[7],
             MENU_CLIENT_DATA,  7,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[8],
             MENU_CLIENT_DATA,  8,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[9],
             MENU_CLIENT_DATA,  9,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[10],
             MENU_CLIENT_DATA,  10,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[11],
             MENU_CLIENT_DATA,  11,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[12],
             MENU_CLIENT_DATA,  12,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[13],
             MENU_CLIENT_DATA,  13,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[14],
             MENU_CLIENT_DATA,  14,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[15],
             MENU_CLIENT_DATA,  15,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[16],
             MENU_CLIENT_DATA,  16,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[17],
             MENU_CLIENT_DATA,  17,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[18],
             MENU_CLIENT_DATA,  18,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[19],
             MENU_CLIENT_DATA,  19,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[20],
             MENU_CLIENT_DATA,  20,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[21],
             MENU_CLIENT_DATA,  21,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[22],
             MENU_CLIENT_DATA,  22,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           MENU_ITEM,
             MENU_STRING,       compilername_buf[23],
             MENU_CLIENT_DATA,  23,
             MENU_NOTIFY_PROC,  select_conf,
             NULL,
           NULL),
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Edit configuration",
         MENU_NOTIFY_PROC,  edit_config,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Edit print options",
         MENU_NOTIFY_PROC,  edit_print_config,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Choose font",
         MENU_NOTIFY_PROC,  Set_font,
         NULL,
       /*MENU_ITEM,
         MENU_STRING,      "Save setup",
         MENU_NOTIFY_PROC,  save_setup,
         NULL,*/
      NULL);
  execmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_ITEM,
         MENU_STRING,      "Compile current file",
         MENU_NOTIFY_PROC,  Compile,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Run Xwin application",
         MENU_NOTIFY_PROC,  RunX,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Run in foreground",
         MENU_NOTIFY_PROC,  Run, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Break execution",
         MENU_NOTIFY_PROC,  Break,
         NULL,
       NULL);
  helpmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_ITEM,
         MENU_STRING,      "Copyright",
         MENU_NOTIFY_PROC,  Copyright,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "About",
         MENU_NOTIFY_PROC,  Helpabout,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Quick introduction",
         MENU_NOTIFY_PROC,  Helpquick ,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Summary",
         MENU_NOTIFY_PROC,  Helpdetail, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "WWW home page",
         MENU_NOTIFY_PROC,  WWW_Home, 
         NULL,
      NULL);
  xv_set(filemenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(toolmenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(optmenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(execmenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(helpmenu, MENU_DONE_PROC, menu_done, NULL);

  textswmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_TITLE_ITEM, "Text tools",
       MENU_ITEM,
         MENU_STRING,      "Undo",
         MENU_NOTIFY_PROC,  Undo,
         NULL,
       MENU_ITEM,  
         MENU_STRING,         "Find",
         MENU_PULLRIGHT,
         xv_create(panel ,     MENU,
           MENU_ITEM,
             MENU_STRING,        "searching forward", 
             MENU_CLIENT_DATA,    0,
            MENU_NOTIFY_PROC,     Find,
             NULL,
           MENU_ITEM,
             MENU_STRING,        "searching backward", 
             MENU_CLIENT_DATA,    1,
            MENU_NOTIFY_PROC,     Find,
             NULL,
           NULL),
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Replace",
         MENU_NOTIFY_PROC,  Replace,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Special",
         MENU_PULLRIGHT,
         xv_create(panel,   MENU,
         MENU_ITEM,
           MENU_STRING,      "Column add/del",
           MENU_NOTIFY_PROC,  Insert_column, 
           NULL,
         MENU_ITEM,
           MENU_STRING,      "Grep",
           MENU_NOTIFY_PROC,  Grep,
           NULL,
         MENU_ITEM,
           MENU_STRING,      "Diff",
           MENU_NOTIFY_PROC,  Diff,
           NULL,
         NULL),
       NULL,
       MENU_ITEM,
         MENU_STRING,      "Cut string",
         MENU_NOTIFY_PROC,  Cut_string, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Copy string",
         MENU_NOTIFY_PROC,  Copy_string, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Insert string",
         MENU_NOTIFY_PROC,  Insert_string, 
         NULL,
     NULL); 
  compilermenu = (Menu) xv_create((int)NULL, MENU,
       MENU_TITLE_ITEM, "Compiler tools",
       MENU_ITEM,
         MENU_STRING,      "Compile current file",
         MENU_NOTIFY_PROC,  Compile,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Run Xwin application",
         MENU_NOTIFY_PROC,  RunX,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Run in foreground",
         MENU_NOTIFY_PROC,  Run, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Break execution",
         MENU_NOTIFY_PROC,  Break,
         NULL,
       NULL);
  terminalmenu = (Menu) xv_create((int)NULL, MENU,
       MENU_TITLE_ITEM, "Terminal tools",
         MENU_ITEM,
           MENU_STRING,      "Grep",
           MENU_NOTIFY_PROC,  Grep,
           NULL,
       MENU_ITEM,
         MENU_STRING,      "Copy string",
         MENU_NOTIFY_PROC,  Copy_string, 
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Insert string",
         MENU_NOTIFY_PROC,  Insert_string_in_terminal, 
         NULL,
       NULL);
  xv_set(textswmenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(compilermenu, MENU_DONE_PROC, menu_done, NULL);
  xv_set(terminalmenu, MENU_DONE_PROC, ttysw_menu_done, NULL);
       
  /* Initialize menu buttons */
   panel = (Panel)xv_create (frame, PANEL, 
       XV_X,                     0,
       XV_Y,                     0,
       WIN_ROWS,                 1,
       NULL);

  (void)xv_create (panel, PANEL_BUTTON,
       PANEL_LABEL_STRING,       "File",
       /*PANEL_LABEL_BOLD,         TRUE,*/
       PANEL_ITEM_MENU,          filemenu,
       NULL);
  (void)xv_create (panel, PANEL_BUTTON,
       PANEL_LABEL_STRING,       "Tools",
       PANEL_ITEM_MENU,          toolmenu,
       NULL);
  (void)xv_create (panel, PANEL_BUTTON,
       PANEL_LABEL_STRING,       "Options",
       PANEL_ITEM_MENU,          optmenu,
       NULL);
  (void)xv_create (panel, PANEL_BUTTON,
       PANEL_LABEL_STRING,       "Execute",
       PANEL_ITEM_MENU,          execmenu,
       NULL);
  (void)xv_create (panel, PANEL_BUTTON,
       PANEL_LABEL_STRING,       "Help",   
       PANEL_ITEM_MENU,          helpmenu,
       NULL);

  /* Canvas: root for Editor */
  canvas = (Canvas)xv_create (frame, CANVAS,
       CANVAS_RESIZE_PROC,  canvas_repaint,
       CANVAS_REPAINT_PROC,  canvas_repaint,
       CANVAS_AUTO_SHRINK,   TRUE,
       CANVAS_AUTO_EXPAND,   TRUE,
       XV_X,            0,
       WIN_BELOW,       panel,
       XV_WIDTH,        xv_get(frame, XV_WIDTH),
       XV_HEIGHT,       xv_get(frame, XV_HEIGHT)-25,
       NULL);
  
  showbuttons=1; showtty=1;
  Create_side_buttons();

  /* Text-subwindow */
  edited=1;
  textsw = (Textsw)xv_create(canvas,TEXTSW,
       TEXTSW_MEMORY_MAXIMUM,     textsw_buf_size,
       TEXTSW_AUTO_INDENT,        TRUE,
       XV_X,                      xv_get(button_panel, XV_WIDTH),
       XV_Y,                      0,
       XV_WIDTH,                  xv_get(canvas, XV_WIDTH)-xv_get(button_panel, XV_WIDTH),
       XV_HEIGHT,                 (xv_get(canvas, XV_HEIGHT)/5)*4,
       TEXTSW_NOTIFY_PROC,        textsw_notifyproc,
       TEXTSW_MENU,               textswmenu,
       NULL);

  if (text_back_color!=0 || text_fore_color!=7)
    xv_set(textsw, 
         WIN_CMS,              cms,
         WIN_BACKGROUND_COLOR, text_back_color,
         WIN_FOREGROUND_COLOR, text_fore_color,
         NULL);
  
  /* Load fonts */
  textswfont     = (Xv_Font)xv_find(frame, FONT, FONT_NAME, spec_font, NULL);
  projtextswfont = (Xv_Font)xv_find(frame, FONT, FONT_NAME, spec_font_proj, NULL);
  if (!textswfont)
    printf("Configuration's font not found, using standard\n");
  else
    xv_set(textsw, TEXTSW_FONT, textswfont, NULL);

   /* Required Configuration for graphic Display */ 
  piccanvas_xid     = (XID)      xv_get (canvas_paint_window(canvas), XV_XID);
  if(!(font = XLoadQueryFont(display, "fixed")))  
  { printf("cannot find fixed font\n"); exit(1); }
  gc_val.font = font->fid;
  gc_val.stipple = XCreateBitmapFromData(display, piccanvas_xid, stipple_bits, 16, 2);
  gc = XCreateGC(display, piccanvas_xid, GCFont | GCStipple, &gc_val);
    
  server = (Xv_Server)xv_get ( xv_get(frame, XV_SCREEN), SCREEN_SERVER );

  /* Picture-Subwindow */
  piccanvas = (Canvas) xv_create (canvas, CANVAS,
       CANVAS_REPAINT_PROC,    piccanvas_repaint,
       CANVAS_X_PAINT_WINDOW,  TRUE,
       WIN_DYNAMIC_VISUAL,     FALSE,
       XV_X,                   0,
       WIN_BELOW,              textsw,
       XV_WIDTH,               (215*xv_get(canvas, XV_HEIGHT))/700,
       XV_HEIGHT,              xv_get(canvas, XV_HEIGHT)-xv_get(textsw, XV_HEIGHT),
       NULL); 

  xv_set(piccanvas, WIN_CMS, cms, NULL);
       
  colors = (unsigned long *)xv_get (piccanvas, WIN_X_COLOR_INDICES);

  /* Tty-Subwindow */
  tty = (Tty)xv_create (canvas, TERMSW,
       XV_X,              xv_get(piccanvas, XV_WIDTH),
       WIN_BELOW,         textsw,
       XV_WIDTH,          xv_get(canvas, XV_WIDTH)-xv_get(piccanvas, XV_WIDTH), 
       XV_HEIGHT,         xv_get(canvas, XV_HEIGHT)-xv_get(textsw, XV_HEIGHT),
       WIN_MENU,          terminalmenu,
       NULL);

  if (text_back_color!=0 || text_fore_color!=7)
    xv_set(tty, 
         WIN_CMS,              cms,
         /*XV_VISUAL_CLASS,      PseudoColor,*/
         WIN_BACKGROUND_COLOR, text_back_color,
         WIN_FOREGROUND_COLOR, text_fore_color,
         NULL);

  window_fit(frame);
  window_fit(canvas);

/* File to load given as an argument ? */
  if (argv[1]!=NULL)
  {
    if (strcmplen(argv[1],file_directory))
      filenamep=Create_string(argv[1]+strlen(file_directory)+1);
    else
      filenamep=Create_string(argv[1]);
      
    /* File existant ? */
    if (fp = fopen(filenamep, "r"))
    {
        fclose(fp);
      /* File readonly ? */
      if (!(fp = fopen(filenamep, "r+")))
      {
        xv_set(textsw, 
            TEXTSW_FILE,       filenamep,
            TEXTSW_FIRST,      0,
            TEXTSW_STATUS,     &textswstatus,
            TEXTSW_BROWSING,   TRUE,
            NULL);
        if (!(set_file_type()))
        {free(filenamep); filenamep=Create_string("");}
        tmpstring = malloc(strlen((char *)xv_get(frame,FRAME_LABEL)) + strlen(" - readonly") + 1);
        sprintf(tmpstring, "%s - readonly", xv_get(frame,FRAME_LABEL));
        xv_set(frame, FRAME_LABEL, tmpstring, NULL);
        free(tmpstring);     
      }
      else
      {
        fclose(fp);
        xv_set(textsw, 
            TEXTSW_FILE,       filenamep,
            TEXTSW_FIRST,      0,
            TEXTSW_STATUS,     &textswstatus,
            TEXTSW_BROWSING,   FALSE,
            NULL);
        if (!(set_file_type()))
        {free(filenamep); filenamep=Create_string("");}
      }
    } 
    else
    filenamep=Create_string("");
  }
  else
    filenamep=Create_string("");
  
  edited=0;
  xv_main_loop (frame) ;
  exit(0);
}

static void
menu_done(menu, result)
Menu            menu;
Xv_opaque	    result;
{
  /* Show cursor */
  textsw_thaw_caret(textsw_folio_for_view(textsw_view_abs_to_rep(textsw)));
  textsw_stablize(textsw_folio_for_view(textsw_view_abs_to_rep(textsw)));
}

static void
ttysw_menu_done(menu, result)
Menu            menu;
Xv_opaque	    result;
{
  /* Show cursor */
  textsw_thaw_caret(textsw_folio_for_view(textsw_view_abs_to_rep(tty)));
  textsw_stablize(textsw_folio_for_view(textsw_view_abs_to_rep(tty)));
}

static void
menu_done_proj(menu, result)
Menu            menu;
Xv_opaque	result;
{
  int windownr=xv_get(menu, MENU_CLIENT_DATA);
  /* Show cursor */
  textsw_thaw_caret(textsw_folio_for_view(
    textsw_view_abs_to_rep( textswproj[windownr])));
  textsw_stablize(textsw_folio_for_view(
    textsw_view_abs_to_rep( textswproj[windownr])));
}

Create_side_buttons()
{
  int textswheight;
  if (showtty==0)
    textswheight=xv_get(canvas, XV_HEIGHT);
  else
    textswheight=xv_get(canvas, XV_HEIGHT)*4/5;
  
  /* Create extra buttons for the most frequently used operations */
  if (textswheight<400)
    button_panel = (Panel)xv_create (canvas, PANEL, 
        XV_X,                    0,
        XV_Y,                    0,
        WIN_ROWS,                2,
        WIN_COLUMNS,             8,
        PANEL_ITEM_X_GAP,        7,
        PANEL_ITEM_Y_GAP, 
        (int) (textswheight-180)/8,
/*        WIN_CMS,                 cms,
         WIN_BACKGROUND_COLOR, 6,
         WIN_FOREGROUND_COLOR, 15,*/
        NULL);
  else
    button_panel = (Panel)xv_create (canvas, PANEL, 
        XV_X,                    0,
        XV_Y,                    0,
        WIN_ROWS,                1,
        PANEL_ITEM_Y_GAP,        
        (int) (textswheight-350)/16,
/*        WIN_CMS,                 cms,
         WIN_BACKGROUND_COLOR, 6,
         WIN_FOREGROUND_COLOR, 15,*/
        
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  open_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Filechooseropen1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  savebutton = xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  save_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Save1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  quit_bits,
           NULL),
        PANEL_NOTIFY_PROC,      Quit1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  line_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Linenumber1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  findr_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Find1,
        PANEL_CLIENT_DATA,      0,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  findl_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Find1,
        PANEL_CLIENT_DATA,      1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  findnr_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Findnext1,
        PANEL_CLIENT_DATA,      0,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  findnl_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Findnext1,
        PANEL_CLIENT_DATA,      1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  cut_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Cut_string1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  copy_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Copy_string1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  insert_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Insert_string1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  compilebutton1 = xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Compile1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  runXbutton1 = xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  runx_bits,
            NULL),
        PANEL_NOTIFY_PROC,      RunX1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  runbutton1 = xv_create(button_panel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  run_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Run1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  if (textswheight<400)
    xv_set(button_panel,
        XV_WIDTH,                68,
        XV_HEIGHT,               (xv_get(canvas, XV_HEIGHT)/5)*4,
        NULL);        
  else
    xv_set(button_panel,
        XV_WIDTH,                34,
        XV_HEIGHT,               (xv_get(canvas, XV_HEIGHT)/5)*4,
        NULL);
        
  if ((compilerrunning && toupper(term_disable_buf[compnum][1])=='Y') || edited==0)
    xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
  if (compilerrunning && toupper(term_disable_buf[compnum][1])=='Y')
  {
    xv_set(compilebutton1, PANEL_BUSY, TRUE, NULL);
    xv_set(runXbutton1, PANEL_INACTIVE, TRUE, NULL);
    xv_set(runbutton1, PANEL_INACTIVE, TRUE, NULL);
    xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);  
  }
}

/* initialise one string with another one*/
char *Create_string(string)
char *string;
{
  return strcpy( malloc((int) strlen(string)+1), string);
}

/* compare two string til the end of one of them */
int strcmplen(string1, string2)
char *string1; 
char *string2;
{
  long len1 = strlen(string1);
  long len2 = strlen(string2);
  long len = (len1 > len2 ? len2 : len1)-1;
  while (len>=0)
  {
    if (string1[len]!=string2[len])
      return 0;
    len--;
  }
  return 1;
}

int checktextswstatus()
{
  Panel mypanel;
  FILE *fp;
  char xx[1];
  if (textswstatus != TEXTSW_STATUS_OKAY)
  {  
    if (textswstatus==TEXTSW_STATUS_BAD_ATTR || textswstatus==TEXTSW_STATUS_BAD_ATTR_VALUE)
    {
      mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
      notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, "Internal attribute error", NULL,
        NOTICE_BUTTON_YES,      "Ok",
        NULL);
    }
    else
      if (textswstatus==TEXTSW_STATUS_CANNOT_ALLOCATE ||
          textswstatus==TEXTSW_STATUS_OUT_OF_MEMORY)
      {
        mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
        notice_prompt(mypanel, NULL,
          NOTICE_MESSAGE_STRINGS, "Out of memory error", NULL,
          NOTICE_BUTTON_YES,      "Ok",
          NULL);
      }
      else
        if (textswstatus==TEXTSW_STATUS_CANNOT_OPEN_INPUT ||
            textswstatus==TEXTSW_STATUS_CANNOT_INSERT_FROM_FILE)
        {
         mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
            notice_prompt(mypanel, NULL,
            NOTICE_MESSAGE_STRINGS, "File couldn't be opened", NULL,
            NOTICE_BUTTON_YES,      "Ok",
            NULL);
        }
        else
          if (textswstatus==TEXTSW_STATUS_OTHER_ERROR)
          {
           mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
              notice_prompt(mypanel, NULL,
              NOTICE_MESSAGE_STRINGS, "File operation failed", NULL,
              NOTICE_BUTTON_YES,      "Ok",
              NULL);
          }
    return 0;
  }  
  return 1;
}

void
textsw_notifyproc()
{
  char *tempstr;
  int temp;
  if (edited) return;
  temp=edited;
  if ((int)xv_get (textsw, TEXTSW_MODIFIED) == TRUE) edited=1; else edited=0;
  if (temp!=edited)
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filenamep)+14);
    sprintf(tempstr, "%s: <%s> - edited", compilername_buf[compnum], filenamep);
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    free(tempstr);
    if ((compilerrunning==0 || toupper(term_disable_buf[compnum][1])=='N') &&
         button_panel!=0)
      xv_set(savebutton, PANEL_INACTIVE, FALSE, NULL);
  }
}

int
set_file_type()
{
  int i,j,k,aktu;
  char *tempstr; 
  char source_tmp_buf [256] ;
  if(checktextswstatus())  /* file accessable ?  */
  {        
    /* try to recognize file type and set configuration */
    aktu=1;
    i=compnum;
    while (i<numconfigs || aktu)
    {
      j=0;
      while (source_buf[i][j]!='\0' && j<256 && source_buf[i][j]!=' ')
      {
        k=j;
        for(;(source_buf[i][j]!=' ' && source_buf[i][j]!='\0');j++)
              source_tmp_buf[j-k]=source_buf[i][j];
        source_tmp_buf[j-k]='\0';
        j++;
        if ((int)strlen(filenamep)>=(int)strlen(source_tmp_buf))
          if (!(strcmp(source_tmp_buf, filenamep+strlen(filenamep)-strlen(source_tmp_buf))))
          {
            compnum=i;
            i=numconfigs;
            current_extension=Create_string(source_tmp_buf);
            aktu=0;
          }
      }
      i++;
      if (aktu)  { aktu=0; i=0; }
    }
    if (i==numconfigs) 
      compnum=MAXCONFIGS;
    tempstr=(char *)malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
    sprintf(tempstr, "%s: <%s>", compilername_buf[compnum], filenamep );
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    evaluate_errmess();
    free(tempstr);
    return 1;
  }
     
  /* file doesn't exist or can't be opened */
  tempstr=(char *)malloc(strlen("No File")+1);
  sprintf(tempstr, "No File");
  xv_set(frame, FRAME_LABEL, tempstr, NULL);
  free(tempstr);
  filenamep=Create_string("");
  return 0;
}

int
getedittext()
{
  int result;

  filename[0]='\0';
  result = textsw_append_file_name(textsw, filename);
  free(filenamep);
  filenamep = Create_string(filename);
  return(result);
  /*return(textsw_append_file_name(textsw, filename) );*/
}

void 
Saved_notify()
{ 
  int result;
  Panel mypanel;
  char *tempstr;
  int i;
  
  /* first check what has been edited */
  for (i=0; i<MAXPROJECTS; i++)
    if (projframe[i]!=0)
      proj_Saved_ntfy(i);
  
  if (getedittext()!=0) return;
  if((int)xv_get (textsw, TEXTSW_MODIFIED) != FALSE)
  {  
    mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
    if (saveconfirmation[0] == 'N' || saveconfirmation[0] == 'N' || saveconfirmation[0] == 'A')
      result = NOTICE_YES;
    else
      result = notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, xv_get(frame, FRAME_LABEL), "Save this file ?", NULL,
        NOTICE_BUTTON_YES,      "SAVE",
        NOTICE_BUTTON_NO,       "Don't save",
        NULL);
    if (result==NOTICE_YES)
    {
      i=textsw_store_file(textsw, filename, 0, 0);
      if (i!=0) return;
      tempstr=malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
      sprintf(tempstr, "%s: <%s>", compilername_buf[compnum], filenamep);
      xv_set(frame, FRAME_LABEL, tempstr, NULL);
      edited=0;
      free(tempstr);
      if (button_panel!=0)
        xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
    }
  }
  if (saveconfirmation[0] == 'A' || saveconfirmation[0] == 'a')
    saveconfirmation[0] = 'Y';
}

void     
New_text_frame(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  ttysw_input (tty, "xwb &\n", strlen("xwb &\n"));
}

void     
Current_text_frame(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int result;
  Panel mypanel;
  long int end = (Textsw_index)xv_get (textsw, TEXTSW_LENGTH);
  mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "REALLY CLEAR TEXT WINDOW?", NULL,
      NOTICE_BUTTON_YES,      "Do it",
      NOTICE_BUTTON_NO,       "cancel",
      NULL);
  if (result==NOTICE_YES)
  {
    char *tempstr; 
    Saved_notify();
    textsw_erase(textsw, 0, end);
    compnum=MAXCONFIGS;
    xv_set(textsw, TEXTSW_FILE_CONTENTS, "", TEXTSW_FIRST, 0, NULL);
    tempstr=(char *)malloc(strlen("No File")+1);
    sprintf(tempstr, "No File");
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    free(tempstr);
    filenamep=Create_string("");    
  }
}

void Ok_open_flist();
void Ok_project_flist();
void Ok_save_flist();
void Filechooseropen2() ;
void Compile2      () ;
void RunX2         () ;
void Run2          () ;
void Break2        () ;
void Save2         () ;


static int
flistnotify( item, dir, file, client_data, op, event, row )
     File_list item;
     char *dir;
     char *file;
     Xv_opaque client_data;
     Panel_list_op op;
     Event *event;
     int row;
{
  if (xv_get(filechooser, FILE_LIST_ROW_TYPE, row)==FILE_LIST_DOTDOT_TYPE || 
      xv_get(filechooser, FILE_LIST_ROW_TYPE, row)==FILE_LIST_DIR_TYPE) return;
  
  if (save_file_text!=0)
    xv_set(save_file_text, PANEL_VALUE, file, NULL);
  
  free(filenamep);
  filenamep=Create_string(file);

  /* double-click: */
  if(op==PANEL_LIST_OP_DBL_CLICK)
    if (save_file_text!=0)
      Ok_save_flist((Panel_item)0); /* item value not used anyway */
    else
      if (strlen(filenamep)>7 && 
          strcmplen(filenamep+strlen(filenamep)-8, ".project")==1)
        Ok_project_flist((Panel_item)0);
      else
        Ok_open_flist((Panel_item)0);
}

static int
flistchdir( list, path, sbuf, op )
     File_list list;
     char *path;
     struct stat *sbuf;
     File_list_op op;
{
  int fchsize;
  char *cutpath;

  if (strcmp(path, working_directory) || didchangepath) 
    didchangepath = 1; else return ;

  if ((int)strlen(path)>PATH_TEXT_L)
    cutpath=Create_string(path+(strlen(path)-PATH_TEXT_L));
  else
    cutpath=Create_string(path);
  xv_set(Filech_path_text, PANEL_VALUE, cutpath, NULL);
  free(cutpath);

  free(working_directory);  
  working_directory=Create_string(path);
  
  /*if (save_file_text!=0)
    xv_set(save_file_text, PANEL_VALUE, "", NULL);*/

  xv_set(filechooser, XV_WIDTH, 300, NULL);
  
  /*fchsize=xv_get(filechooser, XV_WIDTH)+6+100;
  xv_set(Filech_panel, XV_WIDTH, fchsize, NULL);
  window_fit(Filech_frame);*/
}

void 
Ok_open_flist(item)
Panel_item   item;
{  
  int i=0,j,k;
  char *tempstr;
  FILE *fp;
  char *tmpstring;

  if (didchangepath == 1)
  {
    chdir(working_directory);
    ttysw_input (tty, "cd ", 3);
    ttysw_input (tty, working_directory, strlen(working_directory));
    ttysw_input (tty, "\n", 1);
    free(file_directory);
    file_directory=Create_string(working_directory);
  }

  /* File readonly? */
  if (!(fp = fopen(filenamep, "r+")))
  {
    xv_set(textsw, 
        TEXTSW_FILE,       filenamep,
        TEXTSW_FIRST,      0,
        TEXTSW_STATUS,     &textswstatus,
        TEXTSW_BROWSING,   TRUE,
        NULL);
    isreadonly=1;
    if (!(set_file_type()))
      return;
    else
    {
      tmpstring = malloc(strlen((char *)xv_get(frame,FRAME_LABEL)) + strlen(" - readonly") + 1);
      sprintf(tmpstring, "%s - readonly", xv_get(frame,FRAME_LABEL));
      xv_set(frame, FRAME_LABEL, tmpstring, NULL);
      free(tmpstring);
    }
  }
  else
  {
   fclose(fp);
    isreadonly=0;
    xv_set(textsw, 
        TEXTSW_FILE,       filenamep,
        TEXTSW_FIRST,      0,
        TEXTSW_STATUS,     &textswstatus,
        TEXTSW_BROWSING,   FALSE,
        NULL);
    if (!(set_file_type()))
      return;
    /* Adapt error messages to new file */ 
  }
  
  xv_set(textsw, TEXTSW_FILE, filenamep, TEXTSW_STATUS, &textswstatus, NULL);
  if (button_panel!=0)
    xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
  
  edited=0;
  xv_destroy_safe (Filech_frame);
  Filech_frame=0;
  
  xv_set(textsw, TEXTSW_NOTIFY_PROC, textsw_notifyproc, NULL);
}

void 
projUndo(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  char *tempstr;
  int nr=xv_get(menu_item, PANEL_CLIENT_DATA);
  if ((int)xv_get (textswproj[nr], TEXTSW_MODIFIED) == TRUE)
    textsw_undo(textsw_folio_for_view(textsw_view_abs_to_rep(textswproj[nr])));

  if ((int)xv_get (textswproj[nr], TEXTSW_MODIFIED) == FALSE) 
  {
    /*if (isreadonly)
    {
      tempstr=malloc(strlen((char *)xv_get(projframe[nr], FRAME_LABEL))-8 
              +strlen(" - readonly"));
      sprintf(tempstr, "%s - readonly", xv_get(projframe[nr], FRAME_LABEL));
    } 
    else
    {*/
      tempstr=malloc(strlen((char *)xv_get(projframe[nr], FRAME_LABEL))-8);
      sprintf(tempstr, "%s", xv_get(projframe[nr], FRAME_LABEL));
    /*} */
    xv_set(projframe[nr], FRAME_LABEL, tempstr, NULL);
    free(tempstr);
    xv_set(saveprojbutton[nr], PANEL_INACTIVE, FALSE, NULL);
    projedited[nr]=0;
  }
}

void 
saveproj(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int i;
  char *tempstr;
  int nr=xv_get(menu_item, MENU_CLIENT_DATA);
  char tmpfilename[256];
  tmpfilename[0]='\0';
  textsw_append_file_name(textswproj[nr], tmpfilename);

  if (!strcmp(tmpfilename, (char *)xv_get(projframe[nr], FRAME_LABEL, tempstr)))
    return;
  i=textsw_store_file(textswproj[nr], tmpfilename, 0, 0);
  if (i!=0) return;


  xv_set(saveprojbutton[nr], PANEL_INACTIVE, TRUE, NULL);
  tempstr=malloc(strlen((char *)xv_get(projframe[nr], FRAME_LABEL))+10);
  sprintf(tempstr, "%s", xv_get(projframe[nr], FRAME_LABEL));
  tempstr[strlen(tempstr)-9]='\0';
  xv_set(projframe[nr], FRAME_LABEL, tempstr, NULL);
  projedited[nr]=0;
  free(tempstr);
}

void 
saveproj1(item)
Panel_item   item;
{
  int i;
  char *tempstr;
  int nr=xv_get(item, PANEL_CLIENT_DATA);
  char tmpfilename[256];
  tmpfilename[0]='\0';
  textsw_append_file_name(textswproj[nr], tmpfilename);

  if (!strcmp(tmpfilename, (char *)xv_get(projframe[nr], FRAME_LABEL, tempstr)))
    return;
  i=textsw_store_file(textswproj[nr], tmpfilename, 0, 0);
  if (i!=0) return;


  xv_set(saveprojbutton[nr], PANEL_INACTIVE, TRUE, NULL);
  tempstr=malloc(strlen((char *)xv_get(projframe[nr], FRAME_LABEL))+10);
  sprintf(tempstr, "%s", xv_get(projframe[nr], FRAME_LABEL));
  tempstr[strlen(tempstr)-9]='\0';
  xv_set(projframe[nr], FRAME_LABEL, tempstr, NULL);
  projedited[nr]=0;
  free(tempstr);
}


/* functions for editing multiple files */
void
projtextsw_notifyproc(textsw, attributes)
Textsw          textsw;
Attr_avlist     attributes;
{
  char *tempstr;
  int temp;
  int nr=xv_get(textsw, TEXTSW_CLIENT_DATA) ;/* textsw is local */


  if (projedited[nr]) return;
  temp=projedited[nr];
  if ((int)xv_get (textswproj[nr], TEXTSW_MODIFIED) == TRUE) projedited[nr]=1;
    else projedited[nr]=0;
  if (temp!=projedited[nr])
  {
    tempstr=malloc(strlen((char *)xv_get(projframe[nr], FRAME_LABEL))+10);
    sprintf(tempstr, "%s - edited", xv_get(projframe[nr], FRAME_LABEL));
    xv_set(projframe[nr], FRAME_LABEL, tempstr, NULL);
    free(tempstr);
    xv_set(saveprojbutton[nr], PANEL_INACTIVE, FALSE, NULL);
  }
}

void
proj_set_line_number(windownr, num)
long windownr;
long num;
{
  long i,j=0,k=0;
  char buf[2];

  long int end = (Textsw_index)xv_get (textswproj[windownr], TEXTSW_LENGTH)-1;

  if (windownr<0)
    if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
  i=num;
  while (i>0)
  {
    if ((Textsw_index)xv_get (textswproj[windownr], TEXTSW_CONTENTS, j, buf, 1)<1 || j>end)
    {
      error_line_number();
      return;
    }
    j++;
    if(buf[0]=='\n') i--;
  }
  textsw_possibly_normalize(textswproj[windownr], j);
  buf[0]=' ';
  while (buf[0]!='\n')
  {
    if ((Textsw_index)xv_get (textswproj[windownr], TEXTSW_CONTENTS, j+k, buf, 1)<1 || j+k>end)
    {
      error_line_number();
      return;
    }
    k++;
  }
  textsw_set_selection(textswproj[windownr], j, j+k, 1);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
}

void
proj_request_line_number(item)
Panel_item  item;
{
  long num;
  num = atol((char *)xv_get(item, PANEL_VALUE));
  proj_set_line_number(xv_get(item, PANEL_CLIENT_DATA), num-1);
}

void 
projlinenumber(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  long int      value;
  int nr=xv_get(menu_item, MENU_CLIENT_DATA);

  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  
  getselectionproc();
  
  if ((value=atol(varbuffer))>0)   proj_set_line_number(nr, atol(varbuffer)-1);
  else
  {
    opt_text = (Panel_item)xv_create (projpanel[nr], PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Select line number ",
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          proj_request_line_number,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_VALUE_STORED_LENGTH,  256,
        PANEL_CLIENT_DATA,          nr,
        NULL);
    xv_set(projpanel[nr], PANEL_CARET_ITEM, opt_text, NULL);
  }
}

void 
projlinenumber1(item)
Panel_item   item;
{
  long int      value;
  int nr=xv_get(item, PANEL_CLIENT_DATA);

  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  
  getselectionproc();
  
  if ((value=atol(varbuffer))>0)   proj_set_line_number(nr, atol(varbuffer)-1);
  else
  {
    opt_text = (Panel_item)xv_create (projpanel[nr], PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Select line number ",
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          proj_request_line_number,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_VALUE_STORED_LENGTH,  256,
        PANEL_CLIENT_DATA,          nr,
        NULL);
    xv_set(projpanel[nr], PANEL_CARET_ITEM, opt_text, NULL);
  }
}

int
proj_search_string(windownr, client)
long windownr;
int  client;
{
  int result;
  Panel mypanel;

  Textsw_index where;
  Textsw_index *first_p = malloc(sizeof(Textsw_index));
  Textsw_index *lastplusone_p = malloc(sizeof(Textsw_index));
  *first_p = cursorpos;
  *lastplusone_p = (Textsw_index)xv_get (textswproj[windownr], TEXTSW_LENGTH)-1;
  where = textsw_find_bytes(textswproj[windownr], first_p, lastplusone_p, findstring, strlen(findstring), client);


  if (where<0)
  {
    *first_p = 0;
    *lastplusone_p = cursorpos;
    where = textsw_find_bytes(textswproj[windownr], first_p, lastplusone_p, findstring, strlen(findstring), 0);
  }
  if (where>-1) 
  {  
    textsw_possibly_normalize(textswproj[windownr], where);
    textsw_set_selection(textswproj[windownr], where, where+strlen(findstring), 1);
    if  (client==0)
      xv_set(textswproj[windownr], TEXTSW_INSERTION_POINT, *lastplusone_p, NULL);
    else
      xv_set(textswproj[windownr], TEXTSW_INSERTION_POINT, *first_p, NULL);
    free(first_p); free(lastplusone_p);
    return 1;
  } 
  free(first_p); free(lastplusone_p);
  mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
    NOTICE_MESSAGE_STRINGS, "Search string not found", NULL,
    NOTICE_BUTTON_YES,      "OK",
    NULL);
  return 0;
}

int
proj_set_find_string(item, event)
Panel_item  item;
Event *event;
{
  int nr=xv_get(item, PANEL_CLIENT_DATA);

  free(findstring);
  findstring=malloc(strlen((char *)xv_get(item, PANEL_VALUE))+1);
  sprintf(findstring, "%s", xv_get(item, PANEL_VALUE));

  if (proj_search_string(nr, 0)>0)
    if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
}

void 
projFind(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int nr=xv_get(menu_item, MENU_CLIENT_DATA);

  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  cursorpos = (Textsw_index)xv_get (textswproj[nr], TEXTSW_INSERTION_POINT);
  
  getselectionproc();
  
  free(findstring);
  findstring = Create_string(varbuffer);
  if ((int)strlen(varbuffer)>0) 
    proj_search_string(nr, 0);
  else
  {
    opt_text = (Panel_item)xv_create (projpanel[nr], PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Search for -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          proj_set_find_string,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
        PANEL_CLIENT_DATA,          nr,
        NULL);
    xv_set(projpanel[nr], PANEL_CARET_ITEM, opt_text, NULL);
  }

}

void 
projFind1(item)
Panel_item   item;
{
  /*register*/ char *ptr;
  int nr=xv_get(item, PANEL_CLIENT_DATA);

  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  cursorpos = (Textsw_index)xv_get (textswproj[nr], TEXTSW_INSERTION_POINT);
  
  getselectionproc();
  
  free(findstring);
  findstring = Create_string(varbuffer);
  if ((int)strlen(varbuffer)>0) 
    proj_search_string(nr, 0);
  else
  {
    opt_text = (Panel_item)xv_create (projpanel[nr], PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Search for -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          proj_set_find_string,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
        PANEL_CLIENT_DATA,          nr,
        NULL);
    xv_set(projpanel[nr], PANEL_CARET_ITEM, opt_text, NULL);
  }

}

void 
projinsert_string2(nr)
int nr;
{
  Seln_holder   holder;
  Seln_request *response;

  if (xv_get(textswproj[nr], TEXTSW_BROWSING) == TRUE) return;

  /*getselectionproc();*/
  
  holder = selection_inquire(server, SELN_PRIMARY);
  (void)selection_ask(server, &holder,
      SELN_REQ_DELETE, NULL,
      NULL);
      
  textsw_insert(textswproj[nr], copytext, strlen(copytext) );
}

void 
projinsert_string(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int nr=xv_get(menu_item, MENU_CLIENT_DATA);

  projinsert_string2(nr);
}

void 
projinsert_string1(item)
Panel_item   item;
{
  int nr=xv_get(item, PANEL_CLIENT_DATA);

  projinsert_string2(nr);
}

void proj_Saved_ntfy(int nr)
{
  Panel mypanel;
  int i, result;
  
  if((int)xv_get (textswproj[nr], TEXTSW_MODIFIED) != FALSE)
  {  
    if (saveconfirmation[0] != 'N' && saveconfirmation[0] != 'n' && saveconfirmation[0] != 'A' && saveconfirmation[0] != 'a')
    {
      mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
      
      result = notice_prompt(mypanel, NULL,
          NOTICE_MESSAGE_STRINGS, "Save all edited files ?", NULL,
          NOTICE_BUTTON_YES,      "Yes",
          NOTICE_BUTTON_NO,       "No",
          NULL);
          
      if (result==NOTICE_YES)
        saveconfirmation[0] = 'A';
      else 
        saveconfirmation[0] = 'a';
    }
    
    mypanel = (Panel)xv_get (projpanel[nr] , PANEL_PARENT_PANEL);
    if (saveconfirmation[0] == 'N' || saveconfirmation[0] == 'N' 
     || saveconfirmation[0] == 'A')
      result = NOTICE_YES;
    else
    result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, xv_get(projframe[nr], FRAME_LABEL), "Save this file ?", NULL,
      NOTICE_BUTTON_YES,      "SAVE",
      NOTICE_BUTTON_NO,       "Don't save",
      NULL);
    if (result==NOTICE_YES)
    {
      char tmpfilename[256];
      tmpfilename[0]='\0';
      textsw_append_file_name(textswproj[nr], tmpfilename);
      i=textsw_store_file(textswproj[nr], tmpfilename, 0, 0);
      if (i!=0) return;

      xv_set(projframe[nr], FRAME_LABEL, tmpfilename, NULL);
      projedited[nr]=0;
    }
  }
}

void 
closeproj(item)
Panel_item   item;
{
  int nr=xv_get(item, PANEL_CLIENT_DATA);
  proj_Saved_ntfy(nr);
  textsw_erase(textswproj[nr], 0, 
    (Textsw_index)xv_get (textswproj[nr], TEXTSW_LENGTH));
  xv_set(textswproj[nr], TEXTSW_FILE_CONTENTS, "", TEXTSW_FIRST, 0, NULL);
  projedited[nr]=0;
  xv_destroy_safe (projframe[nr]);
  projframe[nr]=0;
}

void 
Ok_project_flist(item)
Panel_item   item;
{
  FILE *fp, *fp_proj;
  int result;
  char xx[256];
  char *tmp_buf, *projfilenamep;
  long int i, j;
  Panel mypanel;
  
  for (i=0; i<MAXPROJECTS; i++)
    if (projframe[i]!=0)
    {
      mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
      result = notice_prompt(mypanel, NULL,
          NOTICE_MESSAGE_STRINGS, "Close all project windows first", NULL,
          NOTICE_BUTTON_YES,      " I'll do that",
          NULL);
      xv_destroy_safe (Filech_frame);
      Filech_frame=0;
      return;
    }
  
  if (didchangepath == 1)
  {
    chdir(working_directory);
    ttysw_input (tty, "cd ", 3);
    ttysw_input (tty, working_directory, strlen(working_directory));
    ttysw_input (tty, "\n", 1);
    free(file_directory);
    file_directory=Create_string(working_directory);
  }

  /* get contents of project file */
  numberproj=j=0;
  if(!(fp = fopen(filenamep,"r"))) return;
  while(j==0 || (xx[j-1]!='\n' && xx[j-1]!='\0'))
  { 
    if(fread( xx+j, 1, 1, fp)==0) return;
    j++; 
  }
  xx[j-1]='\0';

  /* use main frame first */
  free(filenamep);
  filenamep=malloc(strlen(xx));
  sprintf(filenamep, xx);
  Ok_open_flist(item);

  while (numberproj<projitems)
  { 
    j=0;
    while(j==0 || (xx[j-1]!='\n' && xx[j-1]!='\0'))
    { 
      if (fread( xx+j, 1, 1, fp)==0) return;
      j++;
    }
    xx[j-1]='\0';
    
    projfilenamep=malloc(strlen(xx)+1);
    sprintf(projfilenamep, xx);
    if(!(fp_proj = fopen(projfilenamep, "r"))) return;
    fclose(fp_proj);
    free(projfilenamep);
        
    projframe[numberproj] = (Frame)xv_create ((int)NULL, FRAME, 
        FRAME_LABEL,     xx,
        XV_WIDTH,        projhorizontalsize,
        XV_HEIGHT,       projverticalsize,
        NULL) ;
    projpanel[numberproj] = (Frame)xv_create (projframe[numberproj], PANEL,
        XV_X,                     0,
        XV_Y,                     0,
        WIN_ROWS,                 1,
        NULL);
    saveprojbutton[numberproj] = xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  save_bits,
            NULL),
        PANEL_NOTIFY_PROC,      saveproj1,
        PANEL_CLIENT_DATA,      numberproj,
        PANEL_INACTIVE,         TRUE,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        NULL);
  (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  line_bits,
            NULL),
        PANEL_NOTIFY_PROC,      projlinenumber1,
        PANEL_CLIENT_DATA,      numberproj,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        NULL);
   (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  findr_bits,
            NULL),
        PANEL_NOTIFY_PROC,      projFind1,
        PANEL_CLIENT_DATA,      numberproj,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  cut_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Cut_string1,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  copy_bits,
            NULL),
        PANEL_NOTIFY_PROC,      Copy_string1,
        PANEL_CLIENT_DATA,      numberproj,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  insert_bits,
            NULL),
        PANEL_NOTIFY_PROC,      projinsert_string1,
        PANEL_CLIENT_DATA,      numberproj,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);
  (void)xv_create(projpanel[numberproj], PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  close_bits,
           NULL),
        PANEL_NOTIFY_PROC,      closeproj,
        PANEL_CLIENT_DATA,      numberproj,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
/*PANEL_ITEM_COLOR, 3,*/
        NULL);

  projmenu[numberproj] = (Menu) xv_create((int)NULL, MENU,
       MENU_TITLE_ITEM, "Text tools",
       /*MENU_ITEM,
         MENU_STRING,      "Undo",
         MENU_NOTIFY_PROC,  projUndo,
         MENU_CLIENT_DATA,  numberproj,
         NULL,*/
       MENU_ITEM,
         MENU_STRING,      "Save",
         MENU_NOTIFY_PROC,  saveproj,
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Line number",
         MENU_NOTIFY_PROC,  projlinenumber,
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Find",
         MENU_NOTIFY_PROC,  projFind, 
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Cut",
         MENU_NOTIFY_PROC,  Cut_string,
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Copy",
         MENU_NOTIFY_PROC,  Copy_string,
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       MENU_ITEM,
         MENU_STRING,      "Insert",
         MENU_NOTIFY_PROC,  projinsert_string,
         MENU_CLIENT_DATA,  numberproj,
         NULL,
       NULL);
    xv_set(projmenu[numberproj], 
         MENU_CLIENT_DATA,  numberproj,
         MENU_DONE_PROC,    menu_done_proj, 
         NULL);

    xv_set(projpanel[numberproj],
        XV_HEIGHT,                34,
        NULL);  
    textswproj[numberproj] = (Textsw)xv_create(projframe[numberproj], TEXTSW,
      TEXTSW_MEMORY_MAXIMUM,     textsw_proj_buf_size,
      TEXTSW_AUTO_INDENT,        TRUE,
      XV_X,                      0,
      TEXTSW_CLIENT_DATA,        numberproj,
      WIN_BELOW,                 projpanel[numberproj],
      NULL);
    xv_set(textswproj[numberproj], 
      TEXTSW_FILE,               xx,
      TEXTSW_NOTIFY_PROC,        projtextsw_notifyproc,
      TEXTSW_MENU,               projmenu[numberproj],
      NULL);
    if (projtextswfont)
      xv_set(textswproj[numberproj], TEXTSW_FONT, projtextswfont, NULL);
    
    xv_set(projframe[numberproj], XV_SHOW, TRUE, NULL);
    numberproj++;
  }
  fclose(fp);
}

void 
Ok_save_flist(item)
Panel_item   item;
{  
  int i=0;
  char *tempstr;
  
  tempstr=Create_string(xv_get(save_file_text, PANEL_VALUE));
  if ( '\0'==(char)*(tempstr) )  { free(tempstr); xv_destroy_safe (Filech_frame);
                                   Filech_frame=0; return; }
  chdir(working_directory);
  i=textsw_store_file(textsw, tempstr, 0, 0);
  if (i!=0) {chdir(file_directory); return;}
  if (button_panel!=0)
    xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
  if (didchangepath == 1)
  {
    ttysw_input (tty, "cd ", 3);
    ttysw_input (tty, working_directory, strlen(working_directory));
    ttysw_input (tty, "\n", 1);
    free(file_directory);
    file_directory = Create_string(working_directory);
  }
  
  free(filenamep);
  filenamep=Create_string(tempstr);  
  free(tempstr);
  
  if (!set_file_type()) return;
  xv_set(textsw, TEXTSW_BROWSING, FALSE, NULL);

  edited=0;
  tempstr=malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
  sprintf(tempstr, "%s: <%s>",compilername_buf[compnum],filenamep);
  if (xv_set(frame, FRAME_LABEL, tempstr, NULL)) edited=0;
  xv_destroy_safe (Filech_frame);
  Filech_frame=0;
  save_file_text=0;
}

void Cancel_button(item)
Panel_item  item;
{
  if (didchangepath == 1)
  {
    ttysw_input (tty, "cd ", 3);
    ttysw_input (tty, working_directory, strlen(working_directory));
    ttysw_input (tty, "\n", 1);
  }
  /*xv_destroy_safe(Filech_frame);*/
  Filech_frame=0;
  getedittext();
}

void 
Filechooseropen(menu_item, op)
Menu_item     menu_item;
Menu_generate op;
{
  Filechooseropen2();
}

void 
Filechooseropen1(item)
Panel_item     item;
{
  Filechooseropen2();
}

void
Filech_repaint()
{
  xv_set(Filech_panel, XV_WIDTH, xv_get(filechooser, XV_WIDTH)+6+100, NULL);
  window_fit(Filech_frame);
}

int mod(int x, int y)
{
  while (x>y)
    x-=y;
  return x+y;
} 

static void
Set_filelist_opt(item, value, event )
     Panel_choice_item item;
     int value;
     Event *event;
{
  xv_set(filechooser, FILE_LIST_SHOW_DOT_FILES, value, NULL);
}

void 
Filechooseropen2()
{
  int fchsize;
  char *cutpath;

  if (Filech_frame!=0)  return;
  Saved_notify ();
  didchangepath = 0;
  save_file_text=0;
  Filech_frame = (Frame)xv_create (frame, FRAME_CMD, 
       FRAME_LABEL,            "Select a file to open",
       FRAME_SHOW_FOOTER,      TRUE,
             /* WIN_TOP_LEVEL_NO_DECOR, TRUE,*/
       XV_X,                      xv_get(frame, XV_X)+16,
       XV_Y,                      xv_get(frame, XV_Y)+13,
      NULL) ;
  Filech_panel = (Panel)xv_get(Filech_frame, FRAME_CMD_PANEL);
  xv_set(Filech_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
  if ((int)strlen(working_directory)>PATH_TEXT_L)
    cutpath=Create_string(working_directory+(strlen(working_directory)-PATH_TEXT_L));
  else
    cutpath=Create_string(working_directory);
  Filech_path_text = xv_create(Filech_panel, PANEL_TEXT,
		    PANEL_READ_ONLY,		TRUE,
                    PANEL_VALUE_DISPLAY_LENGTH, PATH_TEXT_L,
		    PANEL_LABEL_STRING,		"Current path:",
		    PANEL_VALUE,		(cutpath)
		    					? cutpath
		    					: "",
		    PANEL_VALUE_UNDERLINED,	FALSE,
		    /*PANEL_VALUE_STORED_LENGTH,  PATH_TEXT_L,*/
		    PANEL_LAYOUT,		PANEL_VERTICAL,
		    NULL);
  free(cutpath);
  filechooser = xv_create(Filech_panel, FILE_LIST, 
  		    FILE_LIST_CHANGE_DIR_FUNC,  flistchdir,
		    PANEL_NOTIFY_PROC,		flistnotify,
		    FILE_LIST_DIRECTORY,	working_directory,
		    PANEL_LIST_DISPLAY_ROWS,    filech_number_rows,
                    PANEL_LIST_WIDTH,           200,
		    FILE_LIST_USE_FRAME,        TRUE,
/*FILE_LIST_FILTER_STRING, ".c",*/
                    NULL);
  xv_create(Filech_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  OPEN FILE  ",
		    PANEL_NOTIFY_PROC,          Ok_open_flist,
		    NULL);
  xv_set(Filech_panel, 
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    NULL);
  xv_create(Filech_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  cancel  ",
		    PANEL_NOTIFY_PROC,          Cancel_button,
		    NULL);
  xv_set(Filech_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
		    		    
  /*(void)xv_create(Filech_panel, PANEL_MESSAGE, 
                    PANEL_LABEL_STRING,         "===========================", 
                    NULL);*/
 /* (Panel_item)xv_create (Filech_panel, PANEL_TEXT,
                    PANEL_VALUE,                current_extension,
                    PANEL_LABEL_STRING,         "Filter: ",
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_VALUE_DISPLAY_LENGTH, 6,
                    PANEL_VALUE_STORED_LENGTH,  256,
	            *PANEL_NOTIFY_PROC,          Set_filelist_filter,*
	            PANEL_INACTIVE,             TRUE,
                    NULL);*/
  (Panel_item)xv_create (Filech_panel, PANEL_TOGGLE,
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_CHOICE_STRINGS,       
                        "Show hidden files", /*"Directories",*/ NULL,
	            PANEL_NOTIFY_PROC,          Set_filelist_opt,
                    NULL);
  xv_create(Filech_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "Project file",
		    PANEL_NOTIFY_PROC,          Ok_project_flist,
		    NULL);

  window_fit(Filech_panel);
  xv_set(Filech_panel, XV_WIDTH, xv_get(filechooser, XV_WIDTH)+6, 
                       XV_HEIGHT, xv_get(Filech_panel, XV_HEIGHT)-10, NULL);
  window_fit(Filech_frame);
  xv_set(Filech_frame, XV_SHOW, TRUE, NULL);
}

void 
Filechoosersaveas(menu_item, op)
Menu_item     menu_item;
Menu_generate op;
{
  char *cutpath;

  if (Filech_frame!=0)  return;
  didchangepath = 0;
  Filech_frame = (Frame)xv_create ((int)NULL, FRAME_CMD, 
                    FRAME_LABEL,                "Choose a filename to save",
                    FRAME_SHOW_FOOTER,          TRUE,
                    XV_X,                       xv_get(frame, XV_X)+16,
                    XV_Y,                       xv_get(frame, XV_Y)+13,
                    NULL) ;
  Filech_panel = (Panel)xv_get(Filech_frame, FRAME_CMD_PANEL);
  xv_set(Filech_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

  if ((int)strlen(working_directory)>PATH_TEXT_L)
    cutpath=Create_string(working_directory+(strlen(working_directory)-PATH_TEXT_L));
  else
    cutpath=Create_string(working_directory);
  Filech_path_text = xv_create(Filech_panel, PANEL_TEXT,
		    PANEL_READ_ONLY,		TRUE,
                    PANEL_VALUE_DISPLAY_LENGTH, PATH_TEXT_L,
		    PANEL_LABEL_STRING,		"Current path:",
		    PANEL_VALUE,		(cutpath)
		    					? cutpath
		    					: "",
		    PANEL_VALUE_UNDERLINED,	FALSE,
		    /*PANEL_VALUE_STORED_LENGTH,  PATH_TEXT_L,*/
		    PANEL_LAYOUT,		PANEL_VERTICAL,
		    NULL);
  free(cutpath);
  filechooser = xv_create(Filech_panel, FILE_LIST, 
  		    FILE_LIST_CHANGE_DIR_FUNC,  flistchdir,
		    PANEL_NOTIFY_PROC,		flistnotify,
		    FILE_LIST_DIRECTORY,	working_directory,
		    PANEL_DISPLAY_ROWS,	        filech_number_rows,
                    PANEL_LIST_WIDTH,           200,
		    FILE_LIST_USE_FRAME,        TRUE,
                    NULL);
  xv_create(Filech_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "      Ok      ",
		    PANEL_NOTIFY_PROC,          Ok_save_flist,
		    NULL);
  xv_set(Filech_panel, 
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    NULL);
  xv_create(Filech_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  cancel  ",
		    PANEL_NOTIFY_PROC,          Cancel_button,
		    NULL);
  xv_set(Filech_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
  if (strcmp(file_directory,working_directory))
    save_file_text = (Panel_item)xv_create (Filech_panel, PANEL_TEXT,
                    PANEL_LABEL_STRING,         "Filename: ",
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_VALUE_DISPLAY_LENGTH, 12,
                    PANEL_VALUE_STORED_LENGTH,  256,
	            PANEL_NOTIFY_PROC,          Ok_save_flist,
                    NULL);
  else
    save_file_text = (Panel_item)xv_create (Filech_panel, PANEL_TEXT,
                    PANEL_VALUE,                filenamep,
                    PANEL_LABEL_STRING,         "Filename: ",
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_VALUE_DISPLAY_LENGTH, 12,
                    PANEL_VALUE_STORED_LENGTH,  256,
	            PANEL_NOTIFY_PROC,          Ok_save_flist,
                    NULL);
  
  /*(void)xv_create(Filech_panel, PANEL_MESSAGE, 
                    PANEL_LABEL_STRING,         "===========================", 
                    NULL);*/
  /*(Panel_item)xv_create (Filech_panel, PANEL_TEXT,
                    PANEL_VALUE,                current_extension,
                    PANEL_LABEL_STRING,         "Filter: ",
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_VALUE_DISPLAY_LENGTH, 6,
                    PANEL_VALUE_STORED_LENGTH,  256,
	            *PANEL_NOTIFY_PROC,          Set_filelist_filter,*
	            PANEL_INACTIVE,             TRUE,
                    NULL);*/
  (Panel_item)xv_create (Filech_panel, PANEL_TOGGLE,
                    PANEL_LAYOUT,               PANEL_HORIZONTAL,
                    PANEL_CHOICE_STRINGS,       
                        "Hidden files", /*"Directories",*/ NULL,
	            PANEL_NOTIFY_PROC,          Set_filelist_opt,
	            NULL);
                   
  window_fit(Filech_panel);
  xv_set(Filech_panel, XV_WIDTH, xv_get(filechooser, XV_WIDTH)+6, 
                       XV_HEIGHT, xv_get(Filech_panel, XV_HEIGHT)-10, NULL);
  window_fit(Filech_frame);
  xv_set(Filech_frame, XV_SHOW, TRUE, NULL);
}

void 
Save(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Save2();
}

void 
Save1(item)
Panel_item   item;
{
  Save2();
}

void 
Save2()
{
  Panel mypanel;
  char *tempstr;
  int i;
  if (compilerrunning && toupper(term_disable_buf[compnum][1])=='Y') return;
  
  mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);
  if((int)xv_get (textsw, TEXTSW_MODIFIED) == FALSE)
  {
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, "Text has not been modified,  or", "no file name specified", NULL,
        NOTICE_BUTTON_YES,      "Ok",
        NULL);
      xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
  }
  else
  if (getedittext()==0)
  {
    i=textsw_store_file(textsw, filename, 0, 0);
    if (i!=0) return;
    if (button_panel!=0)
      xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
    tempstr=malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
    sprintf(tempstr, "%s: <%s>", compilername_buf[compnum], filenamep);
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    edited=0;
    free(tempstr);
  }
}

void
Print(menu, menu_item)
Menu        menu;
Menu_item   menu_item;
{
  int result;
  Panel mypanel;
  char *printstring;
  char *printer_filename;
  FILE *fp, *fpsource;
  char *tmpstring;

  mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
  
  getselectionproc();

  printstring=Create_string(varbuffer); 
  if ((int)strlen(printstring)>0)
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "Print selection?", NULL,
      NOTICE_BUTTON_YES,      "Yes",
      NOTICE_BUTTON,          "cancel", 101,
      NOTICE_BUTTON_NO,       "Print edited file",
      NULL);
  else
  {
    Saved_notify();
    result = notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, "Print file?", NULL,
        NOTICE_BUTTON_YES,       "Yes",
        NOTICE_BUTTON,           "cancel", 101,
        NULL);
  }
  /* print file */
  if ((int)strlen(printstring)>0 && result==NOTICE_YES)
  {
    /*printer_filename = malloc(strlen((char *)printer_buf)+1);*/
    printer_filename=Create_string(printer_buf);
    sprintf(printer_filename, "%s", printer_buf);
    if(!(fp = fopen(printer_filename, "w")))
    {
      result = notice_prompt(mypanel, NULL,
          NOTICE_MESSAGE_STRINGS, "Cannot open printer device", NULL,
          NOTICE_BUTTON_YES,       "Ok",
          NULL);
      return;
    }
    fwrite(printstring, 1, strlen(printstring), fp);
    fclose(fp);
    free(printer_filename);
    free(printstring);
    return;
  }
  /* print selection */
  if ( result==NOTICE_YES || ((int)strlen(printstring)>0 && result==NOTICE_NO) )
  {
    printer_filename = malloc(strlen((char *)printer_buf)+1);
    sprintf(printer_filename, "%s", printer_buf);
    if(!(fp = fopen(printer_filename, "w")))
    {
      result = notice_prompt(mypanel, NULL,
          NOTICE_MESSAGE_STRINGS, "Cannot open printer device", NULL,
          NOTICE_BUTTON_YES,       "Ok",
          NULL);
      return;
    }
    fpsource = fopen(filenamep, "r");
    tmpstring = malloc(1);
    while(fread(tmpstring, 1, 1, fpsource))
      fwrite(tmpstring, 1, 1, fp);
    write(fileno(fp), printstring, strlen(printstring));
    fflush(fp);
    fclose(fp);
    fclose(fpsource);
    free(printer_filename);
    free(printstring);
    free(tmpstring);
    return;
  }
}
 
void 
Printformat_function(char *xx)
{  
  int i, j, result;
  Panel mypanel;
  char temp[4096];
  mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);

  Saved_notify();

  for(i=j=0; xx[i]!='\0' && j<4096; i++)
    if (((int)xx[i]!=92 || xx[i+1]!='n') && xx[i]!='*' && xx[i]!='#')
      temp[j++]=xx[i];
    else
      if ((int)xx[i]==92 && xx[i+1]=='n')
      { 
        temp[j++]='\n';
        i++;
      }
      else
        if (xx[i]=='*')
        { 
          strncpy(temp+j, (char *)filename, strlen(filename)-strlen(current_extension));
          j+=strlen(filename)-strlen(current_extension);
        }
        else
        if (xx[i]=='#')
        { 
          strncpy(temp+j, current_extension, strlen(current_extension));
          j+=strlen(current_extension);
        }
  temp[j++]='\0';
  ttysw_input (tty, temp, strlen(temp));
  ttysw_input (tty, "\n", strlen("\n"));
}

void     
Printformat(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Printformat_function(Create_string(printformat_buf[compnum]));  
}

void     
Printformatoddpages(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Printformat_function(Create_string(printformat_odd_buf[compnum]));  
}

void     
Printformatevenpages(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Printformat_function(Create_string(printformat_even_buf[compnum]));  
}

void     
Preformattedprint(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Printformat_function(Create_string(preformat_print_buf[compnum]));
}


void 
Quit(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Quit2();
}

void 
Quit1(item, event)
Panel_item   item;
Event *event;
{
  Quit2();
}

void 
Quit2()
{
  int i, result;
  Panel mypanel;
  mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "REALLY QUIT?", NULL,
      NOTICE_BUTTON_YES,      "Quit",
      NOTICE_BUTTON_NO,       "cancel",
      NULL);
  
  if (result==NOTICE_YES)
  {    
    Saved_notify();
    printf("\nThanks for using xwb.\n");
    exit(0);
  }
}

void set_line_number();
void request_line_number();

void 
Linenumber(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Linenumber2();
}

void 
Linenumber1(item)
Panel_item   item;
{
  long int      value;

  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }

  /* trying to get selection causes segfault with xview v3.1 under Linux */
#ifndef XVIEW3_1
  Linenumber2();
#else
  opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
      XV_Y,                       8,
      PANEL_LABEL_STRING,        "Select line number ",      
      PANEL_LAYOUT,               PANEL_HORIZONTAL,
      PANEL_NOTIFY_PROC,          request_line_number,
      PANEL_VALUE_DISPLAY_LENGTH, 8,
      PANEL_VALUE_STORED_LENGTH,  256,      
      NULL);
  xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
#endif
}

void 
Linenumber2()
{
  long int      value;
  
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  
  getselectionproc();
  
  if ((value=atol(varbuffer))>0)   set_line_number(atol(varbuffer)-1);
  else
  {
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Select line number ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          request_line_number,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_VALUE_STORED_LENGTH,  256,      
        NULL);
  xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
  }
}

void
request_line_number(item, event)
Panel_item  item;
Event *event;
{
  long num;
  num = atol((char *)xv_get(item, PANEL_VALUE));
  set_line_number(num-1);
}

void
error_line_number(num, end)
char *num; 
char *end;
{
  int result;
  Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, " Line number",
                                "not found",
      NULL,
      NOTICE_BUTTON_YES,      "   Ok   ",
      NULL);
}

void
set_line_number(num)
long num;
{
  long i,j=0,k=0;
  char buf[2];
  long int end = (Textsw_index)xv_get (textsw, TEXTSW_LENGTH)-1;
  if (num<0)
    if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
  i=num;
  while (i>0)
  {
    if ((Textsw_index)xv_get (textsw, TEXTSW_CONTENTS, j, buf, 1)<1 || j>end)
    {
      error_line_number();
      return;
    }
    j++;
    if(buf[0]=='\n') i--;
  }
  textsw_possibly_normalize(textsw, j);
  buf[0]=' ';
  while (buf[0]!='\n')
  {
    if ((Textsw_index)xv_get (textsw, TEXTSW_CONTENTS, j+k, buf, 1)<1 || j+k>end)
    {
      error_line_number();
      return;
    }
    k++;
  } 
  textsw_set_selection(textsw, j, j+k, 1); /*SELN_SECONDARY);*/
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
}

void 
Undoall(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int result;
  char *tempstr;
  Panel mypanel;

  if (getedittext()!=0 || isreadonly) return;
  if ((int)xv_get (textsw, TEXTSW_MODIFIED) == FALSE) return;

  mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "Undo all changes ?", NULL,
      NOTICE_BUTTON_YES,      "Ok",
      NOTICE_BUTTON_NO,       "cancel",
      NULL);
  if (result==NOTICE_YES)
  {
    textsw_reset(textsw, 0, 0);
    tempstr=malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
    sprintf(tempstr, "%s: <%s>", compilername_buf[compnum], filenamep);
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    edited=0;
    free(tempstr);
    if (button_panel!=0)
      xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
  }
}

void 
Undo(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  char *tempstr;

  if (isreadonly) return;
  if ((int)xv_get (textsw, TEXTSW_MODIFIED) == TRUE) 
    textsw_undo(textsw_folio_for_view(textsw_view_abs_to_rep(textsw)));

  if ((int)xv_get (textsw, TEXTSW_MODIFIED) == FALSE) 
  {
    tempstr=malloc(strlen(compilername_buf[compnum])+strlen(filenamep)+5);
    sprintf(tempstr, "%s: <%s>", compilername_buf[compnum], filenamep);
    xv_set(frame, FRAME_LABEL, tempstr, NULL);
    edited=0;
    free(tempstr);
    if (button_panel!=0)
      xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
    return;
  }
}

void 
Redo(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  /*textsw_again(textsw_view_abs_to_rep(textsw), locx, locy);*/
}

void 
Find(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Find2(xv_get(menu_item, MENU_CLIENT_DATA));
}

int set_find_string();

void 
Find1(item)
Panel_item   item;
{
  /* trying to get selection causes segfault with xview v3.1 under Linux */
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);

#ifndef XVIEW3_1
  Find2(xv_get(item, PANEL_CLIENT_DATA));
#else
  opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
      XV_Y,                       8,
      PANEL_LABEL_STRING,        "Search for -> ",      
      PANEL_LAYOUT,               PANEL_HORIZONTAL,
      PANEL_NOTIFY_PROC,          set_find_string,
      PANEL_CLIENT_DATA,          xv_get(item, PANEL_CLIENT_DATA),
      PANEL_VALUE_DISPLAY_LENGTH, 30,
      PANEL_VALUE_STORED_LENGTH,  256,
    NULL);
  xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
#endif
}


Seln_result
read_selection(response)
Seln_request *response;
{
  char *reply;
  long seln_len;
  static long seln_have_bytes;
  char *seln_bufs[6];

  if (*response->requester.context == 0) 
  {
    reply = response->data;
    reply += sizeof(SELN_REQ_BYTESIZE);

    seln_len = *(int *)reply;
    reply += sizeof(long);
      
    free(varbuffer);
    if (!(varbuffer = malloc(seln_len + 1)))
    {
      varbuffer  = malloc(2);      sprintf(varbuffer, "");
      return SELN_FAILED;
    } 
      
    seln_have_bytes = 0;

    reply += sizeof(SELN_REQ_CONTENTS_ASCII);
      *response->requester.context != 0;
  } 
  else 
  {
    reply = response->data;
  }

  /* copy data from received to the seln buffer allocated above */
  (void) strcpy(&varbuffer[seln_have_bytes], reply);
  seln_have_bytes += strlen(reply);
    
  return SELN_SUCCESS;
}


/* get the current selection */
/* allow HUGE strings        */
void getselectionproc()
{
  Seln_holder   holder;
  Seln_result   result;
  Seln_request  *posireq;
  char context = 0;
  /*register*/ char *ptr;
  
  holder = selection_inquire(server, SELN_PRIMARY);
  /* Get position of cursor */
  posireq = selection_ask(server, &holder,
      SELN_REQ_FIRST,             NULL,
      SELN_REQ_LAST,              NULL,
      NULL);  
  ptr = posireq->data;
  first = *(Textsw_index *)(ptr += sizeof(SELN_REQ_FIRST));
  ptr += sizeof(Textsw_index); 
  last  = *(Textsw_index *)(ptr += sizeof(SELN_REQ_LAST));

  /* Get results of selection */
  result = selection_query(server, &holder, read_selection, &context,
      SELN_REQ_BYTESIZE,          NULL,
      SELN_REQ_CONTENTS_ASCII,    NULL,
      NULL);
}

void 
Find2(direction)
int   direction;
{
  Panel_item item;

  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }

  getselectionproc();

  if ((int)strlen(varbuffer)>0) 
  {
    free(findstring);
    findstring = Create_string(varbuffer);
    if (direction==0)
    cursorpos = last+1; else cursorpos = first;
    search_string(direction);
  }
  else  
  {
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Search for -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          set_find_string,
        PANEL_CLIENT_DATA,          direction,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
      NULL);
      xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
  }
}

int
set_find_string(item, event)
Panel_item  item;
Event *event;
{
  free(findstring);
  findstring=malloc(strlen((char *)xv_get(item, PANEL_VALUE))+1);
  sprintf(findstring, "%s", xv_get(item, PANEL_VALUE));
  if (search_string(xv_get(item, PANEL_CLIENT_DATA))>0)
    if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
}

void 
Findnext(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  search_string(xv_get(menu_item, MENU_CLIENT_DATA));
}

void 
Findnext1(item)
Panel_item   item;
{
  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  search_string(xv_get(item, PANEL_CLIENT_DATA));
}

int
search_string(client)
int   client;
{
  int result;
  Panel mypanel;
  Textsw_index where;
  Textsw_index *first_p = malloc(sizeof(Textsw_index));
  Textsw_index *lastplusone_p = malloc(sizeof(Textsw_index));
  *first_p = cursorpos;
  *lastplusone_p = (Textsw_index)xv_get (textsw, TEXTSW_LENGTH)-1;
  where = textsw_find_bytes(textsw, first_p, lastplusone_p, findstring, strlen(findstring), client);
  if (where<0)
  {
    *first_p = 0;
    *lastplusone_p = cursorpos;
    where = textsw_find_bytes(textsw, first_p, lastplusone_p, findstring, strlen(findstring), 0);
  }
  if (where>-1) 
  {  
    textsw_possibly_normalize(textsw, where);
    textsw_set_selection(textsw, where, where+strlen(findstring), 1);
    if  (client==0)
      xv_set(textsw, TEXTSW_INSERTION_POINT, *lastplusone_p, NULL);
    else
      xv_set(textsw, TEXTSW_INSERTION_POINT, *first_p, NULL);
    free(first_p); free(lastplusone_p);
    return 1;
  } 
  free(first_p); free(lastplusone_p);
  mypanel = (Panel)xv_get (panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
    NOTICE_MESSAGE_STRINGS, "Search string not found", NULL,
    NOTICE_BUTTON_YES,      "OK",
    NULL);
  return 0;
}

void
grep_string()
{
  char *callstring;

  callstring=malloc(strlen(varbuffer)+8);
  sprintf(callstring, "grep %s *\n", varbuffer);
    
  ttysw_input (tty, callstring, strlen(callstring));
}

int
set_grep_string(item, event)
Panel_item  item;
Event *event;
{
  free(varbuffer);
  varbuffer=malloc(strlen((char *)xv_get(item, PANEL_VALUE))+1);
  sprintf(varbuffer, "%s", xv_get(item, PANEL_VALUE));
  grep_string();
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
}

void
Grep(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Panel_item item;

  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  
  getselectionproc();

  if ((int)strlen(varbuffer)>0) 
  {
    grep_string();
  }
  else  
  {
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Grep string -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          set_grep_string,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
        NULL);
      xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
  }
}

void
Diff(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  char *buff;
  buff=malloc(13);
  sprintf(buff, "diff *# *#%%");
  buff[12]='\0';
  Printformat_function(buff);
}

void 
Replace(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  int set_find_string();
  Panel_item item;

  if (xv_get(textsw, TEXTSW_BROWSING) == TRUE) return;

  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  
  getselectionproc();
  
  free(findstring);
  findstring=malloc(strlen(varbuffer)); 
  strcpy(findstring, varbuffer);
  if ((int)strlen(findstring)>0) 
  {
    cursorpos = first;
    set_replace_string2(); 
  }
  else  
  {
    /*free(findstring);*/
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Replace this -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          set_replace_string,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
      NULL);
      xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
  }
}

void
set_replace_string(item, event)
Panel_item  item;
Event *event;
{
  /*free(findstring);*/
  findstring=malloc(strlen((char *)xv_get(item, PANEL_VALUE))+1);
  sprintf(findstring, "%s", xv_get(item, PANEL_VALUE));
  set_replace_string2();
}

void
set_replace_string2()
{
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
  if (search_string(0))
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "Replace with -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          replace_string,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
    NULL);
    xv_set(panel, PANEL_CARET_ITEM, opt_text, NULL);
}

void
replace_string(item, event)
Panel_item  item;
Event *event;
{
  int result, result1;
  int prompt;
  Textsw_index where, begin, end ;
  Panel mypanel;
  Textsw_index *first_p = malloc(sizeof(Textsw_index)+1);
  Textsw_index *lastplusone_p = malloc(sizeof(Textsw_index)+1);

  replacestring=malloc(strlen((char *)xv_get(item, PANEL_VALUE))+1);

  sprintf(replacestring, "%s", xv_get(item, PANEL_VALUE));

  mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "PROMPT ON REPLACE?", NULL,
      NOTICE_BUTTON_YES,      "prompt",
      NOTICE_BUTTON_NO,       "replace all",
      NOTICE_BUTTON,          "cancel", 101,
      NULL);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0;  }
  if (result==NOTICE_YES)
  {
    prompt = 1;
  }
  else 
    if (result==NOTICE_NO) 
      {
        prompt = 0;
      }
    else 
      { free(findstring); free(replacestring); return;}
  *first_p = begin = cursorpos;
  *lastplusone_p = end = (Textsw_index)xv_get (textsw, TEXTSW_LENGTH)-1;
  result1=NOTICE_YES;
  while(prompt!=2)
  {
    *first_p = begin;
    *lastplusone_p = end;
    
    where = textsw_find_bytes(textsw, first_p, lastplusone_p, findstring, strlen(findstring), 0);
    if (where>end) return;
    if (where<0 || where<begin)
    {
      if (begin==0) return;
      *first_p = begin = 0;
      *lastplusone_p = end = cursorpos-2; 
      // Somewhere wrong recombination of file length
      where = textsw_find_bytes(textsw, first_p, lastplusone_p, findstring, strlen(findstring), 0);
      if (where<0) return;
    }
      if (prompt)
      {
        textsw_possibly_normalize(textsw, where);
        textsw_set_selection(textsw, where, where+strlen(findstring), 1);
        if (result1==NOTICE_YES)
          result = notice_prompt(mypanel, NULL,
             XV_X,                    0,
             XV_Y,                    700,
             NOTICE_MESSAGE_STRINGS, "REPLACE THIS STRING?", NULL,
             NOTICE_BUTTON_YES,      "YES",                            
             NOTICE_BUTTON_NO,       "NO",      
             NOTICE_BUTTON,          "cancel", 101,
             NULL); 
        else
          result = notice_prompt(mypanel, NULL,
             XV_X,                    0,
             XV_Y,                    700,
             NOTICE_MESSAGE_STRINGS, "REPLACE THIS STRING?", NULL,
             NOTICE_BUTTON_NO,       "YES",                            
             NOTICE_BUTTON_YES,      "NO",      
             NOTICE_BUTTON,          "cancel", 101,
             NULL); 
        if ( (result==NOTICE_YES && result1==NOTICE_YES) || 
             (result==NOTICE_NO  && result1==NOTICE_NO ) )
        {
          textsw_replace_bytes( textsw, *first_p, *first_p+strlen(findstring), 
                                replacestring, strlen(replacestring) );
          /* end  += strlen(replacestring)-strlen(findstring); */
          end  += 1;
          result1=NOTICE_YES;
        }
        else 
          if (result!=NOTICE_NO && result!=NOTICE_YES) 
          {
            free(findstring); 
            free(replacestring); 
            return;
          }
        else
        {
          result1=NOTICE_NO;
          end  += 1;
        }
      }
      else 
      {
        textsw_replace_bytes(textsw, *first_p, *first_p+strlen(findstring), replacestring, strlen(replacestring));
        end  += strlen(replacestring)-strlen(findstring);
      }
     begin = where+strlen(replacestring);
  }
  free(findstring); free(replacestring);
}

void 
Copy_string(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Copy_string2();
}

void 
Copy_string1(item)
Panel_item   item;
{
  Copy_string2();
}

void 
Copy_string2()
{
  getselectionproc();

  if ((int)strlen(varbuffer)<=0) 
  {
    Panel mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, 
        "Failed to copy,", 
        " buffer is exceeded or no selection has been made", 
        NULL,
        NOTICE_BUTTON_YES,      "Ok",
        NULL);
    return;
  }

  free (copytext);
  copytext = Create_string(varbuffer);
}

void 
Cut_string(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Cut_string2();
}


void 
Cut_string1(item)
Panel_item   item;
{
  Cut_string2();
}

void 
Cut_string2()
{
  Seln_holder   holder;
  Seln_request *response;

  getselectionproc();
  
  if ((int)strlen(varbuffer)<=0) 
  {
    Panel mypanel = (Panel)xv_get ( panel , PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, 
        "Failed to cut,", 
        " buffer is exceeded or no selection has been made", 
        NULL,
        NOTICE_BUTTON_YES,      "Ok",
        NULL);
    return;
  }

  free (copytext);
  copytext = Create_string(varbuffer);

  holder = selection_inquire(server, SELN_PRIMARY);
  (void)selection_ask(server, &holder,
      SELN_REQ_DELETE, NULL,
      NULL);
}

void 
Insert_string(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Insert_string2();
}

void 
Insert_string1(item)
Panel_item   item;
{
  Insert_string2();
}

void 
Insert_string2()
{
  Seln_holder holder;
  Seln_request *response;
 
  if (xv_get(textsw, TEXTSW_BROWSING) == TRUE) return;

  /*getselectionproc();*/

  holder = selection_inquire(server, SELN_PRIMARY);
  (void)selection_ask(server, &holder,
      SELN_REQ_DELETE, NULL,
      NULL);

  textsw_insert(textsw, copytext, strlen(copytext) ); 
}

void 
Insert_string_in_terminal(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Seln_holder   holder;
  // if (xv_get(textsw, TEXTSW_BROWSING) == TRUE) return;
  holder = selection_inquire(server, SELN_PRIMARY);
  (void)selection_ask(server, &holder,
      SELN_REQ_DELETE, NULL,
      NULL);
  ttysw_input(tty, copytext, strlen(copytext) );
}

void 
Insert_column()
{
  Seln_holder holder;
  Seln_request *response;
  int insert_string_req();
  /*register*/ char *ptr;

  if (xv_get(textsw, TEXTSW_BROWSING) == TRUE) return;

  cursorpos = (Textsw_index)xv_get (textsw, TEXTSW_INSERTION_POINT);
  if (opt_text>0)  { xv_destroy_safe(opt_text); opt_text=0; return; }
  holder = selection_inquire(server, SELN_PRIMARY);
  response = selection_ask(server, &holder,
      SELN_REQ_FIRST,             NULL,
      SELN_REQ_LAST,              NULL,
      SELN_REQ_CONTENTS_ASCII,    NULL,
      NULL);
  ptr = response->data;
  first = *(Textsw_index *)(ptr += sizeof(SELN_REQ_FIRST));
  ptr += sizeof(Textsw_index); 
  last  = *(Textsw_index *)(ptr += sizeof(SELN_REQ_LAST));
  ptr += sizeof(Textsw_index); 
  ptr += sizeof(SELN_REQ_CONTENTS_ASCII);
  findstring=malloc(strlen(ptr)+1); 
  strcpy(findstring, ptr);
  if ((int)strlen(findstring)>0) 
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    opt_text = (Panel_item)xv_create (panel, PANEL_TEXT,
        XV_Y,                       8,
        PANEL_LABEL_STRING,        "String -> ",      
        PANEL_LAYOUT,               PANEL_HORIZONTAL,
        PANEL_NOTIFY_PROC,          insert_string_req,
        PANEL_VALUE_DISPLAY_LENGTH, 30,
        PANEL_VALUE_STORED_LENGTH,  256,
    NULL);
  }
  else  
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, "Please select some",
                                "    lines first   ", NULL,
        NOTICE_BUTTON_YES,      "OK",
        NULL); 
  }
}

int insert_string_req(item, event)
Panel_item  item;
Event *event;
{
  char *row_insertion_string;
  Panel mypanel;
  Textsw_index where ;
  char buf[2];
  int result;
  Textsw_index *first_p = malloc(sizeof(Textsw_index));
  Textsw_index *lastplusone_p = malloc(sizeof(Textsw_index));

  row_insertion_string=malloc((int) 100);
  (void)strncpy(row_insertion_string, (char *)xv_get(item, PANEL_VALUE), (int) 100);
  xv_destroy_safe(opt_text);
  opt_text=0;

  mypanel = (Panel) xv_get(panel, PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "Insert or remove string",
                              " at the beginning / end",
                              "of each selected line ?",
                              "", NULL,
      NOTICE_BUTTON,          "Insert at begin", 101,
      NOTICE_BUTTON,          "Insert at end",   102,
      NOTICE_BUTTON,          "Remove at begin", 103,
      NOTICE_BUTTON,          "Remove at end",   104,
      NOTICE_BUTTON_NO,       "cancel",
      NULL);

  if (result==101 || result==103) 
   if (first>1)
     {
       first--; last--;
     }
   else
     {
       if(result==101)
       {
         xv_set(textsw, TEXTSW_INSERTION_POINT, 0, NULL);
         textsw_insert(textsw, row_insertion_string, strlen(row_insertion_string) );
         first+=strlen(row_insertion_string);
         last+=strlen(row_insertion_string);
       }
     }

  first--; 
     
  while(first<=last) 
  {
    buf[0]=' ';
    while(buf[0]!='\n' && first<=last)
    {
      first++;
      if ((Textsw_index)xv_get (textsw, TEXTSW_CONTENTS, first, buf, 1)<1)
        return;
    }
    if (first>last)
      return;

    if(result==101)
    {
      xv_set(textsw, TEXTSW_INSERTION_POINT, first+1, NULL);
      textsw_insert(textsw, row_insertion_string, strlen(row_insertion_string) );
      first+=strlen(row_insertion_string);
      last+=strlen(row_insertion_string);
      textsw_notifyproc();
    }
    if(result==102)
    {
      xv_set(textsw, TEXTSW_INSERTION_POINT, first, NULL);
      textsw_insert(textsw, row_insertion_string, strlen(row_insertion_string) );
      first+=strlen(row_insertion_string);
      last+=strlen(row_insertion_string);
      textsw_notifyproc();
    }
        /*return;*/
    if (result==103 || result==104)
    {
      *first_p = first;
      *lastplusone_p = last;
      
      if (result==104 && first>=(int)strlen(row_insertion_string))
        *first_p-=strlen(row_insertion_string);
      
      where = textsw_find_bytes(textsw, first_p, lastplusone_p, row_insertion_string, strlen(row_insertion_string), 0);
      
      if (where==first+1 && result==103)
      {
        textsw_erase(textsw, where, where+strlen(row_insertion_string));
        last-=strlen(row_insertion_string);
        textsw_notifyproc();
      }
      if (where==first-strlen(row_insertion_string)  && result==104) 
      {
        textsw_erase(textsw, where, where+strlen(row_insertion_string));
        last-=strlen(row_insertion_string);
        textsw_notifyproc();
      }
    }
  }
}

void Showbuttons(menu,menu_item)
Menu menu; 
Menu_item menu_item; 
{
  showbuttons = (showbuttons == 0 ? 1 : 0);
  canvas_repaint(canvas, 0, display, 0, 0);
}

void Showtty(menu,menu_item)
Menu menu; 
Menu_item menu_item; 
{
  showtty = (showtty == 0 ? 1 : 0);
  canvas_repaint(canvas, 0, display, 0, 0);
}


/* Setup functions: Configuration, fonts et al. */ 

void select_conf(menu,menu_item)
Menu menu; 
Menu_item menu_item; 
{
  char *tempstr;
  getedittext();
  compnum=xv_get(menu_item, MENU_CLIENT_DATA);
  if (edited)
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filenamep)+14);
    sprintf(tempstr, "%s: <%s> - edited", compilername_buf[compnum], filenamep);
  }
  else
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filename)+1);
    sprintf(tempstr,"%s: <%s>",compilername_buf[compnum],filename);
  }
  xv_set(frame, FRAME_LABEL, tempstr, NULL);
  evaluate_errmess();
  free(tempstr);
}

int Cancel_edit_button(item, event)
Panel_item  item;
Event *event;
{
  xv_destroy_safe(Edit_config_frame);
  Edit_config_shown=FALSE;
}

int Ok_edit_button(item, event)
Panel_item  item;
Event *event;
{
  char *tempstr;

  (void)strncpy(compilername_buf[compnum], (char *)xv_get(
      opt_text_compilername, PANEL_VALUE), sizeof compilername_buf[compnum] );
  (void)strncpy(compiler_buf[compnum], (char *)xv_get(
      opt_text_compiler, PANEL_VALUE), sizeof compiler_buf[compnum] );
  (void)strncpy(source_buf[compnum], (char *)xv_get(
      opt_text_source, PANEL_VALUE), sizeof source_buf[compnum] );
  (void)strncpy(exec_buf[compnum], (char *)xv_get(
      opt_text_exec, PANEL_VALUE), sizeof exec_buf[compnum] );
  (void)strncpy(usew_buf[compnum], (char *)xv_get(
      opt_text_usew, PANEL_VALUE), sizeof usew_buf[compnum] );
  (void)strncpy(errmess_buf[compnum], (char *)xv_get(
      opt_text_errmess, PANEL_VALUE), sizeof errmess_buf[compnum] );

  if (xv_get(opt_text_term_disable_a, PANEL_VALUE))
    term_disable_buf[compnum][0]='y';
  else
    term_disable_buf[compnum][0]='n';
  if (xv_get(opt_text_term_disable_b, PANEL_VALUE))
    term_disable_buf[compnum][1]='y';
  else
    term_disable_buf[compnum][1]='n';

  xv_destroy_safe(Edit_config_frame);
  Edit_config_shown=FALSE;

  /* Update changes */
  getedittext();
  if (edited)
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filenamep)+14);
    sprintf(tempstr, "%s: <%s> - edited", compilername_buf[compnum], filenamep);
  }
  else
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filename)+1);
    sprintf(tempstr,"%s: <%s>",compilername_buf[compnum],filename);
  }
  xv_set(frame, FRAME_LABEL, tempstr, NULL);
  evaluate_errmess();
  free(tempstr);
}

void 
edit_config(menu, menu_item)
Menu        menu;
Menu_item   menu_item;
{
  Panel_item item;
  
  if (Edit_config_shown==TRUE) return;
  
  Edit_config_frame = (Frame)xv_create (frame, FRAME_CMD, 
       FRAME_LABEL,            "Edit configuration",
       FRAME_SHOW_FOOTER,      FALSE,
             /* WIN_TOP_LEVEL_NO_DECOR, TRUE,*/
       XV_X,                      xv_get(frame, XV_X)+xv_get(button_panel, XV_WIDTH)/2,
       XV_Y,                      xv_get(frame, XV_Y)+13,
      NULL) ;
      
  Edit_config_panel = (Panel)xv_get(Edit_config_frame, FRAME_CMD_PANEL);
  
  xv_set(Edit_config_panel, 
      PANEL_LAYOUT,                PANEL_VERTICAL,
      PANEL_BORDER,                TRUE,
      NULL);

  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  opt_text_compilername = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                compilername_buf[compnum],
      PANEL_LABEL_STRING,        "     COMPILER DESCRIPTION -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,         
      "------------------- Compiler options -------------------",
       NULL);
  opt_text_compiler = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                compiler_buf[compnum],
      PANEL_LABEL_STRING,        "                     COMPILER CALL -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  opt_text_source = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                source_buf[compnum],
      PANEL_LABEL_STRING,        "     SOURCE FILE EXTENSIONS -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,
      "------------------- Execution options -------------------",
      NULL);
  opt_text_usew = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                usew_buf[compnum],
      PANEL_LABEL_STRING,        "          CALL TARGET FILE WITH -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  opt_text_exec = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                exec_buf[compnum],
      PANEL_LABEL_STRING,        "          TARGET FILE EXTENSION -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,         
      "------------------- Error messages etc. ------------------",
      NULL);
  opt_text_errmess = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                errmess_buf[compnum],
      PANEL_LABEL_STRING,        "              ERROR MESSAGES FORM -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      PANEL_NOTIFY_PROC,          Ok_edit_button,
      NULL);
  opt_text_term_disable_a = (Panel_item)xv_create (Edit_config_panel, 
      PANEL_CHECK_BOX,
      PANEL_LABEL_STRING,        "                COMPILER TERMINATES -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      NULL);
  opt_text_term_disable_b = (Panel_item)xv_create (Edit_config_panel, PANEL_CHECK_BOX,
      PANEL_LABEL_STRING,        "WHILE COMPILING, DISABLE SAVE  -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      NULL);
  if (toupper(term_disable_buf[compnum][0])=='Y')
    xv_set(opt_text_term_disable_a, PANEL_VALUE, 1, NULL);
  if (toupper(term_disable_buf[compnum][1])=='Y')
    xv_set(opt_text_term_disable_b, PANEL_VALUE, 1, NULL);
      
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,         
      "-----------------------------------------------------",
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "Makros:    '*';  '#';  '%';  '\\n'   are replaced by:", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "filename's root;  it's extension;  the line number;  carr. return ", NULL);
   
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);

  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "                          ", NULL);
  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "    OK    ",
		    PANEL_NOTIFY_PROC,          Ok_edit_button,
		    NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "           ", NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  cancel  ",
		    PANEL_NOTIFY_PROC,          Cancel_edit_button,
		    NULL);

  window_fit(Edit_config_panel);
  window_fit(Edit_config_frame);
  xv_set(Edit_config_frame, XV_SHOW, TRUE,   NULL);
  Edit_config_shown=TRUE;
}

int Ok_print_edit_button(item, event)
Panel_item  item;
Event *event;
{
  char *tempstr;

  (void)strncpy(compilername_buf[compnum], (char *)xv_get(
      opt_text_compilername, PANEL_VALUE), sizeof compilername_buf[compnum] );

  (void)strncpy(printer_buf[compnum], (char *)xv_get(
      opt_text_printer, PANEL_VALUE), sizeof printer_buf[compnum] );
  (void)strncpy(printformat_buf[compnum], (char *)xv_get(
      opt_text_printformat, PANEL_VALUE), sizeof printformat_buf[compnum] );
  (void)strncpy(printformat_odd_buf[compnum], (char *)xv_get(
      opt_text_printformat_odd, PANEL_VALUE), sizeof printformat_odd_buf[compnum] );
  (void)strncpy(printformat_even_buf[compnum], (char *)xv_get(
      opt_text_printformat_even, PANEL_VALUE), sizeof printformat_even_buf[compnum] );
  (void)strncpy(preformat_print_buf[compnum], (char *)xv_get(
      opt_text_preformat_print, PANEL_VALUE), sizeof preformat_print_buf[compnum] );

  xv_destroy_safe(Edit_config_frame);
  Edit_config_shown=FALSE;

  /* Update changes */
  getedittext();
  if (edited)
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filenamep)+14);
    sprintf(tempstr, "%s: <%s> - edited", compilername_buf[compnum], filenamep);
  }
  else
  {
    tempstr=malloc(sizeof(compilername_buf[compnum])+sizeof(filename)+1);
    sprintf(tempstr,"%s: <%s>",compilername_buf[compnum],filename);
  }
  xv_set(frame, FRAME_LABEL, tempstr, NULL);
  evaluate_errmess();
  free(tempstr);
}

void 
edit_print_config(menu, menu_item)
Menu        menu;
Menu_item   menu_item;
{
  
  if (Edit_config_shown==TRUE) return;
  
  Edit_config_frame = (Frame)xv_create (frame, FRAME_CMD, 
       FRAME_LABEL,            "Edit print configuration",
       FRAME_SHOW_FOOTER,      FALSE,
             /* WIN_TOP_LEVEL_NO_DECOR, TRUE,*/
       XV_X,                      xv_get(frame, XV_X)+xv_get(button_panel, XV_WIDTH)/2,
       XV_Y,                      xv_get(frame, XV_Y)+13,
      NULL) ;
      
  Edit_config_panel = (Panel)xv_get(Edit_config_frame, FRAME_CMD_PANEL);
  
  xv_set(Edit_config_panel, 
      PANEL_LAYOUT,                PANEL_VERTICAL,
      PANEL_BORDER,                TRUE,
      NULL);
  
  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  opt_text_compilername = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                compilername_buf[compnum],
      PANEL_LABEL_STRING,        "     COMPILER DESCRIPTION -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,         
      "-------------------- Print options -----------------------",
      NULL);
  opt_text_printer = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                printer_buf[compnum],
      PANEL_LABEL_STRING,        "                PRINTER DEVICE FILE -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  256,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  opt_text_printformat = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                printformat_buf[compnum],
      PANEL_LABEL_STRING,        "            FORMATTED PRINT CALL -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  opt_text_printformat_odd = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                printformat_odd_buf[compnum],
      PANEL_LABEL_STRING,        "                       .. FOR ODD PAGES -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  opt_text_printformat_even = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                printformat_even_buf[compnum],
      PANEL_LABEL_STRING,        "                      .. FOR EVEN PAGES -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  opt_text_preformat_print = (Panel_item)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE,                preformat_print_buf[compnum],
      PANEL_LABEL_STRING,        " .. USING A PREFORMATTED FILE -> ",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      PANEL_NOTIFY_PROC,          Ok_print_edit_button,
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING,         
      "-----------------------------------------------------",
      NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "Makros:    '*';  '#';  '%';  '\\n'   are replaced by:", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "filename's root;  it's extension;  the line number;  carr. return ", NULL);
   
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);

  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_VERTICAL, NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "                          ", NULL);
  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "    OK    ",
		    PANEL_NOTIFY_PROC,          Ok_print_edit_button,
		    NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "           ", NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  cancel  ",
		    PANEL_NOTIFY_PROC,          Cancel_edit_button,
		    NULL);

  window_fit(Edit_config_panel);
  window_fit(Edit_config_frame);
  xv_set(Edit_config_frame, XV_SHOW, TRUE,   NULL);
  Edit_config_shown=TRUE;
}

int Set_font_button(item, event)
Panel_item  item;
Event *event;
{
  int addlen=0;
  
  foundry =xv_get(font_foundry, PANEL_VALUE);
  weight = xv_get(font_weight,  PANEL_VALUE);
  size =   xv_get(font_size,    PANEL_VALUE);

  /* Create font name */
  /* Just fiddling with the usual Monospace fonts ... */
  if (foundry==0)
  { 
    switch(size)
    { 
      case 0: 
        sprintf(spec_font+addlen, "5x8"); break;
      case 1:
        sprintf(spec_font+addlen, "6x10"); break;
      case 2:
        sprintf(spec_font+addlen, "6x12"); break;
      case 3:
        sprintf(spec_font+addlen, "7x14"); break;
      case 4:
        sprintf(spec_font+addlen, "10x20"); break;
      case 5:
        sprintf(spec_font+addlen, "12x24"); break;
    }
    addlen=strlen(spec_font);
    switch(weight)
    { 
      case 0: 
        sprintf(spec_font+addlen, "bold"); break;
      case 1:
        sprintf(spec_font+addlen, ""); break;
    }
  }

  if (foundry==1)
  { 
    sprintf(spec_font+addlen, "-schumacher-clean-");
    addlen=strlen(spec_font);
    switch(weight)
    { 
      case 0: 
        sprintf(spec_font+addlen, "bold-"); break;
      case 1:
        sprintf(spec_font+addlen, "medium-"); break;
    }
    addlen=strlen(spec_font);
    switch(size)
    { 
      case 0: 
        sprintf(spec_font+addlen, "r-normal--8-80-75-75-c-60-iso8859-1"); break;
      case 1:
        sprintf(spec_font+addlen, "r-normal--10-100-75-75-c-80-iso8859-1"); break;
      case 2:
        sprintf(spec_font+addlen, "r-normal--12-120-75-75-c-80-iso8859-1"); break;
      case 3:
        sprintf(spec_font+addlen, "r-normal--14-140-75-75-c-80-iso8859-1"); break;
      case 4:
        sprintf(spec_font+addlen, "r-normal--16-160-75-75-c-80-iso8859-1"); break;
      case 5:
        sprintf(spec_font+addlen, "r-normal--16-160-75-75-c-80-iso8859-1");  break;
    }
  }
  
  if (foundry==2)  
  { 
    sprintf(spec_font+addlen, "-adobe-courier-");
    
    addlen=strlen(spec_font);
    switch(weight)
    { 
      case 0: 
        sprintf(spec_font+addlen, "bold-r-normal-"); break;
      case 1:
        sprintf(spec_font+addlen, "medium-r-normal-"); break;
    }
    addlen=strlen(spec_font);
    switch(size)
    { 
      case 0: 
        sprintf(spec_font+addlen, "-8-80-75-75-m-50-iso8859-1"); break;
      case 1:
        sprintf(spec_font+addlen, "-10-100-75-75-m-60-iso8859-1"); break;
      case 2:
        sprintf(spec_font+addlen, "-12-120-75-75-m-70-iso8859-1"); break;
      case 3:
        sprintf(spec_font+addlen, "-14-140-75-75-m-90-iso8859-1"); break;
      case 4:
        sprintf(spec_font+addlen, "-18-180-75-75-m-110-iso8859-1"); break;
      case 5:
        sprintf(spec_font+addlen, "-24-240-75-75-m-150-iso8859-1"); break;
    }
  }
  if (foundry==3)  
  { 
    sprintf(spec_font+addlen, "lucidasanstypewriter-"); 
    addlen=strlen(spec_font);
    switch(weight)
    { 
      case 0: 
        sprintf(spec_font+addlen, "bold-"); break;
      case 1:
        sprintf(spec_font+addlen, ""); break;
    }
    addlen=strlen(spec_font);
    switch(size)
    { 
      case 0: 
        sprintf(spec_font+addlen, "8"); break;
      case 1:
        sprintf(spec_font+addlen, "10"); break;
      case 2:
        sprintf(spec_font+addlen, "12"); break;
      case 3:
        sprintf(spec_font+addlen, "14"); break;
      case 4:
        sprintf(spec_font+addlen, "18"); break;
      case 5:
        sprintf(spec_font+addlen, "24"); break;
    }
  }

  textswfont = (Xv_Font)xv_find(frame, FONT, FONT_NAME, spec_font, NULL);
  if (!textswfont)
    xv_set(test_font, 
            PANEL_LABEL_STRING,   "Font not available",
            NULL);
  else
    xv_set(test_font, 
            PANEL_LABEL_STRING,   spec_font,
            PANEL_LABEL_FONT,     textswfont,     
            NULL);

  window_fit(Edit_config_panel);
  window_fit(Edit_config_frame);
}

int Ok_set_font_button(item, event)
Panel_item  item;
Event *event;
{
  int i;
  if (xv_get(font_for_sw, PANEL_VALUE))
    set_font_for_sw=1;
  else 
    set_font_for_sw=0;
  if (xv_get(font_for_projsw, PANEL_VALUE))
    set_font_for_projsw=1;
  else 
    set_font_for_projsw=0;

  if (!textswfont)
    printf("Font not found.\n");
  else
    if(set_font_for_sw)
      xv_set(textsw, TEXTSW_FONT, textswfont, NULL);

  if(set_font_for_projsw)
  {
    projtextswfont=textswfont;
    for (i=0; i<MAXPROJECTS; i++)
      if (projframe[i]!=0)
        if (projtextswfont)
          xv_set(textswproj[i], TEXTSW_FONT, projtextswfont, NULL);
  }
  xv_destroy_safe(Edit_config_frame);
  Edit_config_shown=FALSE;
}

void 
Set_font(menu, menu_item)
Menu        menu;
Menu_item   menu_item;
{
  Edit_config_frame = (Frame)xv_create (frame, FRAME_CMD, 
       FRAME_LABEL,            "Set font",
       FRAME_SHOW_FOOTER,      FALSE,
             /* WIN_TOP_LEVEL_NO_DECOR, TRUE,*/
       XV_X,                      xv_get(frame, XV_X)+xv_get(button_panel, XV_WIDTH)/2,
       XV_Y,                      xv_get(frame, XV_Y)+13,
      NULL) ;
  Edit_config_panel = (Panel)xv_get(Edit_config_frame, FRAME_CMD_PANEL);
  
  xv_set(Edit_config_panel, 
      PANEL_LAYOUT,                PANEL_VERTICAL,
      PANEL_BORDER,                TRUE,
      NULL);

  (void)xv_create (Edit_config_panel, PANEL_MESSAGE,
      PANEL_LABEL_STRING,          "",
      NULL);
  (void)xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_LABEL_STRING,          "         MONOSPACE FONTS ",
      PANEL_VALUE_DISPLAY_LENGTH,  0,
      PANEL_VALUE_UNDERLINED,	   FALSE,
      PANEL_READ_ONLY,		   TRUE,
      NULL);
  (void)xv_create (Edit_config_panel, PANEL_MESSAGE,
      PANEL_LABEL_STRING,        "",
      NULL);

  font_foundry = (Panel_item)xv_create (Edit_config_panel, PANEL_CHOICE_STACK,
      PANEL_LABEL_STRING,        "Foundry: ",
      PANEL_CHOICE_STRINGS,      "fixed", "clean", "courier", "lucidasanstypewriter", NULL,
      PANEL_VALUE,               foundry,
		    PANEL_NOTIFY_PROC,          Set_font_button,
      NULL);  
  font_weight = (Panel_item)xv_create (Edit_config_panel, PANEL_CHOICE_STACK,
      PANEL_LABEL_STRING,        "Weight:   ",
      PANEL_CHOICE_STRINGS,      "bold", "normal", NULL,
      PANEL_VALUE,               weight,
		    PANEL_NOTIFY_PROC,          Set_font_button,
      NULL);  
  font_size = (Panel_item)xv_create (Edit_config_panel, PANEL_CHOICE_STACK,
      PANEL_LABEL_STRING,        "Size:        ",
      PANEL_CHOICE_STRINGS,      "8", "10", "12", "14", "16/18", "16/24", NULL,
      PANEL_VALUE,               size,
		    PANEL_NOTIFY_PROC,          Set_font_button,
      NULL);  
      
  font_for_sw = (Panel_item)xv_create (Edit_config_panel, PANEL_CHECK_BOX,
      PANEL_LABEL_STRING,        "SET MAIN WINDOW FONT ->",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      NULL);
  font_for_projsw = (Panel_item)xv_create (Edit_config_panel, PANEL_CHECK_BOX,
      PANEL_LABEL_STRING,        "SET PROJECT WINDOW FONT ->",
      PANEL_VALUE_DISPLAY_LENGTH, 20,
      PANEL_VALUE_STORED_LENGTH,  1024,
      NULL);
  if (set_font_for_sw)
    xv_set(font_for_sw, PANEL_VALUE, 1, NULL);
  if (set_font_for_projsw)
    xv_set(font_for_projsw, PANEL_VALUE, 1, NULL);
      
  (void)xv_create (Edit_config_panel, PANEL_MESSAGE,
      PANEL_LABEL_STRING,        "",
      NULL);
       
  test_font=xv_create (Edit_config_panel, PANEL_TEXT,
      PANEL_VALUE_DISPLAY_LENGTH,  0,
      PANEL_VALUE_UNDERLINED,	   FALSE,
      PANEL_READ_ONLY,		   TRUE,
      NULL);
  Set_font_button((Panel_item) 0, (Event *) 0);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "", NULL);

  xv_set(Edit_config_panel, PANEL_LAYOUT, PANEL_HORIZONTAL, NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "    OK    ",
		    PANEL_NOTIFY_PROC,          Ok_set_font_button,
		    NULL);
  (void)xv_create(Edit_config_panel, PANEL_MESSAGE, 
      PANEL_LABEL_STRING, "   ", NULL);
  xv_create(Edit_config_panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING,         "  cancel  ",
		    PANEL_NOTIFY_PROC,          Cancel_edit_button,
		    NULL);
		    
 
  window_fit(Edit_config_panel);
  window_fit(Edit_config_frame);
  xv_set(Edit_config_frame, XV_SHOW, TRUE, NULL);
  Edit_config_shown=TRUE;
}

FILE *open_config_file(method)
char method[];
{
  char configfile[1024];

  sprintf(configfile,"%s/%s", getenv("HOME"), CONFIG_FILE);
  if(!(fp = fopen(configfile, method)))
  {
    /* second attempt: RCDIR/system.xwbrc */
    sprintf(configfile,"%s/system%s", SYSRC, CONFIG_FILE);
    if(!(fp = fopen(configfile, method)))
    {
      sprintf(configfile,"%s/xwb.config", getenv("HOME"));
      if(!(fp = fopen(configfile, method)))
      { 
        if (!strcmp(method, "r")) /* correct ? */
        printf("Error: No configuration file found.\n"); 
        printf("No file \"%s\" in your HOME (%s) directory; \n", CONFIG_FILE, getenv("HOME")); 
        printf("no file \"system%s\" in SYSRC (%s) directory\n", CONFIG_FILE, SYSRC);
        printf("Stopped.\n\n");
      }
    } 
  }
  return fp; 
}


void 
save_setup(menu, menu_item)
Menu        menu;
Menu_item   menu_item;
{
  FILE *fp;
  char xx[16000];
  int  i,j;

  fp = open_config_file("r+");
  xx[0]=' ';


}



/* the next few functions are being used by compiler call */
Notify_value
get_results(client, fd)
Notify_client   client;
register int fd;
{
  char buf[BUFSIZ];
  int bytes, i, j;

  if (ioctl(fd, FIONREAD, &bytes) == 0)
  {
    while (bytes > 0) 
    {
      /* fd is not a file */
      if ((i = read(fd, buf, sizeof buf)) > 0)
      {
        comp_results[result_counter] = strncpy(malloc(i+1), buf, i);

        for(j=0; j<i; j++)
          if  ( ( (int)comp_results[result_counter][j]<32 ||
                  (int)comp_results[result_counter][j]>126) && 
               !(int)comp_results[result_counter][j]==10)
            comp_results[result_counter][j] = ' ';
            
        comp_results[result_counter][i] = '\0';

        result_counter++;
        bytes -= i;
      }
      xv_set(resulttext, TEXTSW_BROWSING, FALSE, NULL);
      if (compwin_txtsize > 0)
        compwin_txtsize = textsw_insert(resulttext, 
            comp_results[result_counter-1], 
            strlen(comp_results[result_counter-1]));
        xv_set(resulttext, TEXTSW_BROWSING, TRUE, NULL);
    }
  }
  return NOTIFY_DONE;
}

Notify_value
child_term(client, pid, status, rusage)
Notify_client client;
int pid;
#ifdef __sun
int *status;
int *rusage;
#else
union wait *status;
struct rusage *rusage;
#endif
{
  int a,b;
  char error_ret_text[256];
  
  if (WIFEXITED(*status)) {
  
    /* set animation off */
    notify_set_itimer_func(frame, NULL, ITIMER_REAL, NULL, NULL);

    #ifdef __sun
    if (*status==0)
    #else
    if (status->w_retcode==0)
    #endif
      xv_set(results_message, PANEL_LABEL_STRING, "+++ Success +++", NULL);
    else
    {
      #ifdef __sun
      if (*status<3)
        sprintf(error_ret_text, "--- Error status %d ---", *status);
      #else
      if (status->w_retcode<3)
        sprintf(error_ret_text, "--- Error status %d ---", status->w_retcode);
      #endif
      else
      #ifdef __sun
        sprintf(error_ret_text, "--- Return code %d ---", *status);
      #else
        sprintf(error_ret_text, "--- Return code %d ---", status->w_retcode);
      #endif
      xv_set(results_message, PANEL_LABEL_STRING, error_ret_text, NULL);
    }
    
    /* unregister input func */
    notify_set_input_func(client, NOTIFY_FUNC_NULL, (client == client1)? pipe_input[0] : 0);    
    for (a=1, b=0; a<result_counter; a++)
      b+=strlen(comp_results[a]);
    comp_results[0]=malloc(b+1);
    b=0;
    for (a=1; a<result_counter; a++)
    {
      strcpy(comp_results[0]+b,comp_results[a]);
      b+=strlen(comp_results[a]);
      free(comp_results[a]);
    }
    comp_results[0][b]='\0';

    if (button_panel!=0)
    {
      xv_set(compilebutton1, PANEL_BUSY, FALSE, NULL);
      xv_set(runXbutton1, PANEL_INACTIVE, FALSE, NULL);
      xv_set(runbutton1, PANEL_INACTIVE, FALSE, NULL);
      xv_set(savebutton, PANEL_INACTIVE, FALSE, NULL);  
    }
    xv_set(compilebutton2, PANEL_BUSY, FALSE, NULL);
    xv_set(runXbutton2, PANEL_INACTIVE, FALSE, NULL);
    xv_set(runbutton2, PANEL_INACTIVE, FALSE, NULL);
    xv_set(closebutton, PANEL_INACTIVE, FALSE, NULL);
    //pid=0;
    
    evaluate_errmess();
    
    compilerrunning=0;

    return NOTIFY_DONE;    
  }
  xv_set(results_message, PANEL_LABEL_STRING, "--- Can't get process ID --- ", NULL);
  return NOTIFY_IGNORED;
}

int my_compare(a, b)
char *a;
char *b;
{
  int n=0;
  while( (char)(*(a+n))!='\0' && 
         (char)(*(a+n)) == (char)(*(b+n)) )
    if( (char)(*(b+n))=='\0' ) return 0;
    else n++;
  return 1;
}

/* Read the error message buffer and      */
/* produce a row of errormess. structures */
void evaluate_errmess()
{
  long int first, last, res_p, crypt_p, lineno, which_window, i;
  res_p=crypt_p=lineno=0;

  if (comp_results[0]==NULL) return;

  /* Free error list */
  while (errorline_pt->lasterrp!=NULL)
    errorline_pt=errorline_pt->lasterrp;
  while (errorline_pt->nexterrp!=NULL)
  {
    errorline_pt=errorline_pt->nexterrp;
    free(errorline_pt->lasterrp);
  }
  free(errorline_pt);
  
  
  /* Allocate new error list first item */
  errorline_pt=malloc(sizeof(struct errorstruct));
  errorline_pt->lasterrp=NULL;
  errorline_pt->nexterrp=NULL;
  errorline_pt->lineno=-1;

  /* Build error list from result array */
  while(*(comp_results[0]+res_p)!='\0')
  {
    first=res_p; last=0;
    which_window=-2;
    
    while ( (errmess_buf[compnum][crypt_p]!='\n') &&
            (errmess_buf[compnum][crypt_p]!='\0') )
    {
      if (errmess_buf[compnum][crypt_p]=='*')
      {
        char *tempstr_cut;
        if (*(comp_results[0]+res_p)=='.' && *(comp_results[0]+res_p+1)=='/')
          res_p+=2;
        tempstr_cut=malloc(strlen(filenamep)-strlen(current_extension)+1);
        strncpy(tempstr_cut, filenamep, strlen(filenamep)-strlen(current_extension));
        *(tempstr_cut+strlen(filenamep)-strlen(current_extension))='\0';

        if (strcmplen(comp_results[0]+res_p, tempstr_cut))
        {
          if (errmess_buf[compnum][crypt_p+1]=='#')
          {
            if (strcmplen(comp_results[0]+res_p
              +(strlen(filenamep)-strlen(current_extension)), current_extension))
            {
              res_p+=strlen(filenamep);
              crypt_p++;
              which_window=-1;
            }
          }
        }
        
        /* search project text subwindows */
        if (errmess_buf[compnum][crypt_p]=='*')
        {
          for (i=0; i<MAXPROJECTS && which_window<0; i++)
          {
            if (projframe[i]!=0)
            {
              char *tempstr;
              tempstr=malloc(strlen((char *)xv_get(projframe[i], FRAME_LABEL))+1);
              sprintf(tempstr, "%s", xv_get(projframe[i], FRAME_LABEL));
              if (projedited[i])
                tempstr[strlen(tempstr)-9]='\0';
              if (strcmplen(tempstr, comp_results[0]+res_p))
              {
                res_p+=strlen(tempstr);
                crypt_p++; /* extension included */
                which_window=i;
              }
              free(tempstr);
            }
          }
        }
      }
      else
        if (errmess_buf[compnum][crypt_p]=='%')
        {
          lineno=atol(comp_results[0]+res_p);
          if (lineno<1) break;
          while ((int) *(comp_results[0]+res_p)>47 &&
                 (int) *(comp_results[0]+res_p)<58)
            res_p++;
          last=res_p;
          break;
        }
        else
          if (errmess_buf[compnum][crypt_p]!=*(comp_results[0]+res_p))
            break;
          else
            res_p++;
      crypt_p++;
    }
    /* Skip rest of Line */
    crypt_p=0;
    while ( (*(comp_results[0]+res_p)!='\n') && (*(comp_results[0]+res_p)!='\0') )
      res_p++;
        
    if (last>0 && which_window>-2)
      {
        /* construction of a new error structure */
        errorline_pt->nexterrp=malloc(sizeof(struct errorstruct));
        errorline_pt->nexterrp->lasterrp=errorline_pt;
  
        errorline_pt=errorline_pt->nexterrp;
        errorline_pt->lineno=lineno;
        errorline_pt->which_window=which_window;
        errorline_pt->nexterrp=NULL;
        errorline_pt->first=first;
        errorline_pt->last=res_p;
      }
    
    if (*(comp_results[0]+res_p)=='\n') res_p++;
  }

  while (errorline_pt->lasterrp!=NULL)
    errorline_pt=errorline_pt->lasterrp;

  if (errorline_pt->nexterrp==NULL)
  {
    xv_set(next_errbutton, PANEL_INACTIVE, TRUE, NULL);
    xv_set(last_errbutton, PANEL_INACTIVE, TRUE, NULL);  
    xv_set(prev_errbutton, PANEL_INACTIVE, TRUE, NULL);
    xv_set(first_errbutton, PANEL_INACTIVE, TRUE, NULL);  
  }
  else
  {
    xv_set(next_errbutton, PANEL_INACTIVE, FALSE, NULL);
    xv_set(last_errbutton, PANEL_INACTIVE, FALSE, NULL);  
  }
}

int to_next_error(item, event)
Panel_item  item;
Event *event;
{
  if ((errorline_pt->nexterrp!=NULL) && (errorline_pt->lasterrp!=NULL))
    xv_set(results_message, PANEL_LABEL_STRING, "--- No errors resolved ---", NULL);

  if (errorline_pt->nexterrp!=NULL)
  {
    char *tmpstring;
    errorline_pt=errorline_pt->nexterrp;
    tmpstring=malloc(strlen("--- Error line  ---") + 16);
    sprintf(tmpstring, "--- Error line %d ---", errorline_pt->lineno);
    xv_set(results_message, PANEL_LABEL_STRING, tmpstring, NULL);
    xv_set(prev_errbutton, PANEL_INACTIVE, FALSE, NULL);
    xv_set(first_errbutton, PANEL_INACTIVE, FALSE, NULL);  

    free(tmpstring);
  }
  else
  {
    xv_set(results_message, PANEL_LABEL_STRING, "--- Last message ---", NULL);
    xv_set(last_errbutton, PANEL_INACTIVE, TRUE, NULL);  
    xv_set(next_errbutton, PANEL_INACTIVE, TRUE, NULL);  
    xv_set(prev_errbutton, PANEL_INACTIVE, FALSE, NULL);
    xv_set(first_errbutton, PANEL_INACTIVE, FALSE, NULL);  
  }
  
  textsw_possibly_normalize(resulttext, errorline_pt->first);
  textsw_set_selection(resulttext, errorline_pt->first, 
    errorline_pt->last, SELN_PRIMARY);
    
  if (errorline_pt->which_window==-1)
    set_line_number(errorline_pt->lineno - 1);
  else
    proj_set_line_number(errorline_pt->which_window, errorline_pt->lineno - 1);
}

int to_prev_error(item, event)
Panel_item  item;
Event *event;
{
  if ((errorline_pt->nexterrp!=NULL) && (errorline_pt->lasterrp!=NULL))
    xv_set(results_message, PANEL_LABEL_STRING, "--- No errors resolved ---", NULL);

  if (errorline_pt->lasterrp!=NULL && errorline_pt->lasterrp->lasterrp!=NULL)
  {
    char *tmpstring;
    errorline_pt=errorline_pt->lasterrp;
    tmpstring=malloc(strlen("--- Error line  ---") + 16);
    sprintf(tmpstring, "--- Error line %d ---", errorline_pt->lineno);
    xv_set(results_message, PANEL_LABEL_STRING, tmpstring, NULL);
    xv_set(next_errbutton, PANEL_INACTIVE, FALSE, NULL);
    xv_set(last_errbutton, PANEL_INACTIVE, FALSE, NULL);  

    free(tmpstring);
  }
  else
  {
    xv_set(results_message, PANEL_LABEL_STRING, "--- First message ---", NULL);
    xv_set(first_errbutton, PANEL_INACTIVE, TRUE, NULL);  
    xv_set(prev_errbutton, PANEL_INACTIVE, TRUE, NULL);  
    xv_set(next_errbutton, PANEL_INACTIVE, FALSE, NULL);
    xv_set(last_errbutton, PANEL_INACTIVE, FALSE, NULL);  
  }

  textsw_possibly_normalize(resulttext, errorline_pt->first);
  textsw_set_selection(resulttext, errorline_pt->first, 
    errorline_pt->last, SELN_PRIMARY);

  if (errorline_pt->which_window==-1)
    set_line_number(errorline_pt->lineno - 1);
  else
    proj_set_line_number(errorline_pt->which_window, errorline_pt->lineno - 1);
}

int to_first_error(item, event)
Panel_item  item;
Event *event;
{
  while (errorline_pt->lasterrp!=NULL && errorline_pt->lasterrp->lasterrp!=NULL)
    errorline_pt=errorline_pt->lasterrp;
  to_prev_error(item, event);
}

int to_last_error(item, event)
Panel_item  item;
Event *event;
{
  while (errorline_pt->nexterrp!=NULL)
    errorline_pt=errorline_pt->nexterrp;
  to_next_error(item, event);
}


int exitresults(item, event)
Panel_item  item;
Event *event;
{
  if (compilerrunning) return;
  textsw_erase(resulttext, 0, (Textsw_index)xv_get (resulttext, TEXTSW_LENGTH));
  xv_destroy_safe(resultframe);
  resultframe=0;
  if (comp_results[0]!=NULL)
    free (comp_results[0]);
  comp_results[0]=NULL;
}

void 
Compile(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Compile2(); 
}

void 
Compile1(item)
Panel_item   item;
{
  Compile2();
}

Notify_value
animation()
{
  /* Simple animation - Just for fun */
  comp_mess_count++;
    
  if ((comp_mess_count)>4) comp_mess_count=0;
  if (comp_mess_count==0)
  {
    xv_set(results_message, PANEL_LABEL_STRING, "*** Compiling *** ", NULL);
    xv_set(compilebutton2,
              PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile1_bits,
            NULL),
      NULL);    
  }
  else
    if (comp_mess_count==1)
    {
      xv_set(results_message, PANEL_LABEL_STRING, "*** Compiling ***   .", NULL);
      xv_set(compilebutton2,
              PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile2_bits,
            NULL),
      NULL);     
            
   }
    else
      if (comp_mess_count==2)
      {
        xv_set(results_message, PANEL_LABEL_STRING, "*** Compiling ***   . .", NULL);
      xv_set(compilebutton2,
              PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile_bits,
            NULL),
      NULL);     
      }
      else
        if (comp_mess_count==3)
        {
          xv_set(results_message, PANEL_LABEL_STRING, "*** Compiling ***   . . .", NULL); 
      xv_set(compilebutton2,
              PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile1_bits,
            NULL),
      NULL);     
        }
        else
        {
          xv_set(results_message, PANEL_LABEL_STRING, "*** Compiling ***   . . . .", NULL); 
        }
  return NOTIFY_DONE;
}

void 
Compile2()
{
  int l,i,j,k,a,b,c,d,e;
  int xposi, yposi;
  char *childparam[256];
  char temp[4096];
  char source_tmp_buf [256] ;
  Panel mypanel;
  int startpoint;
  int apo;
  
  if (compilerrunning || compnum==MAXCONFIGS) return;

  getedittext();
  if (strlen(compiler_buf[compnum])<1) return;

  if ((filenamep==NULL) || !strcmp(filenamep, ""))
  {
    mypanel = (Panel) xv_get(panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO COMPILE BECAUSE: ",
                                "-------------------------------------",
                                "             there's no              ",
                                "             file edited             ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Open file ",
        NULL);
    Filechooseropen();
    return;
  }
  if (strcmp(file_directory,working_directory))
  {
    mypanel = (Panel) xv_get(panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO COMPILE BECAUSE: ",
                                "-------------------------------------",
                                "       directory of edited file      ",
                                "          is different from          ",
                                "          working directory          ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Change path ",
        NULL);
    Filechooseropen();
    return;
  }
    
  for(i=j=0; compiler_buf[compnum][i]!='\0' && j<4096; i++)
    if ((int)compiler_buf[compnum][i]!=92 && compiler_buf[compnum][i]!='*' && 
             compiler_buf[compnum][i]!='#')
      temp[j++]=compiler_buf[compnum][i];
    else
      if (compiler_buf[compnum][i]=='*')
      { 
        if ((int)strlen(filename)-(int)strlen(current_extension)<0 ||
            strcmp(current_extension,
                      filename+strlen(filename)-strlen(current_extension)))
        {
        Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
          notice_prompt(mypanel, NULL,
              NOTICE_MESSAGE_STRINGS, " COULD NOT START TO COMPILE BECAUSE: ",
                                      "-------------------------------------",
                                      "         Source file format          ",
                                      "     differs from configuration      ",
                                      "-------------------------------------",
              NULL,
              NOTICE_BUTTON_YES,      " Cancel ",
              NULL);
          return;
        }
        strncpy(temp+j, (char *)(filename), strlen(filename)-strlen(current_extension));
        j+=strlen(filename)-strlen(current_extension);
      }
      else
        if (compiler_buf[compnum][i]=='#')
        {
          strncpy(temp+j, current_extension, strlen(current_extension));
          j+=strlen(current_extension);
        }      
        else
          if (compiler_buf[compnum][i]==92 && compiler_buf[compnum][i+1]=='n')
          {
            temp[j++]='\n';
            i++;
          }
          else
            temp[j++]=compiler_buf[compnum][i];
            
  Saved_notify();

  if (toupper(term_disable_buf[compnum][0])!='Y')
  {
    Printformat_function(strdup(compiler_buf[compnum]));
    return;
  }

  temp[j++]='\0';
  
  result_counter = 2;

  /* separate calls between \n's */

  startpoint=0; 
  while (startpoint<(int)strlen(temp)+1)
  {
printf("temp  = <%s>\n", temp);  
   while(compilerrunning==1) {/*sleep(1);printf("sleep\n");*/}
    
    apo=0;
  for (k=j=i=startpoint; i<(int)strlen(temp+startpoint)+1 &&
         (temp+startpoint)[i]!='\n'; i++)
  {
/*printf("a\n");*/
    if ((temp+startpoint)[i]=='"')
      if (apo==0)
        apo=1; 
      else 
        apo=0; 
    else
      if ((apo==0 && (temp+startpoint)[i]==' ') || (temp+startpoint)[i]=='\0')
      {
        if (i>j)
        {
          childparam[k] = malloc(i-j+1);
          strncpy(childparam[k], temp+startpoint+j, i-j);
          childparam[k++][i-j]='\0';
          j=i+1;
        }
      }
/*printf("b\n");*/
  }
  startpoint=i+1;
/*printf("Starte <%s> point =%d\n", childparam[0], startpoint);*/
  childparam[k]=NULL;

  pipe (pipe_input);
  switch(pid=fork())
  { 
    case -1: 
      ttysw_input(tty, "Sorry, could not fork a new process, using terminal subwindow", strlen("Sorry, could not fork a new process, using terminal subwindow"));
      close(pipe_input[0]);
      close(pipe_input[1]);
      Printformat_function(strdup(compiler_buf[compnum]));
      return;
      
    case 0:
      dup2(pipe_input[1], 1);
      dup2(pipe_input[1], 2);  

#ifdef __sun
      {    
        struct rlimit rlim;
        getrlimit(RLIMIT_NOFILE, &rlim);
        for (i = rlim.rlim_cur; i > 2; i--)
          (void) close(i);
      }  
#else
      for (i = getdtablesize(); i > 2; i--)
          (void) close(i);
#endif

      for (i = 0; i < NSIG; i++)
          (void) signal(i, SIG_DFL);
      execvp(*childparam,childparam);
      if (errno == ENOENT)
      {
        ttysw_input(tty, *childparam, strlen(*childparam));
        ttysw_input(tty, "not found\n", 10); 
      }
      else
        perror(*childparam);
      perror("execvp");
      return;
      
    default:
      close(pipe_input[1]);
  }

  /* start process */
  notify_set_input_func(client1, get_results, pipe_input[0]);
  notify_set_wait3_func(client1, child_term, pid);

  /* Already installed by main_loop !!!! */
  /*notify_start();*/
  /* causes message:
  XView warning: Notifier error: Invalid argument*/

  /*xposi = xv_get(frame, XV_X)+120;
  yposi = xv_get(frame, XV_Y)-200;
  yposi = ( yposi < -20 ? -20 : yposi);*/

  /* Creation of resultframe */
  if (resultframe==0)
  { 
    Canvas resultcanvas;
    resultframe = (Frame)xv_create ((int)NULL, FRAME, 
        FRAME_LABEL,           "Compiler Results",
        FRAME_ICON,             compilericon,
        /*XV_X,                 xposi,
        XV_Y,                   yposi,*/
        NULL);
                
    resultpanel = (Panel)xv_create(resultframe, PANEL, 
        XV_WIDTH,                800,
        WIN_UNGRAB_SELECT,       NULL,
        NULL);

    resulttext = (Panel_item)xv_create(resultpanel, TEXTSW,
        XV_X,                    4,
        XV_Y,                    4,
        TEXTSW_MEMORY_MAXIMUM,   errmess_buf_size,
        WIN_ROWS,                result_number_rows,
        WIN_COLUMNS,             result_number_columns,
	TEXTSW_DISABLE_CD,       TRUE,
	TEXTSW_DISABLE_LOAD,     TRUE,
	TEXTSW_IGNORE_LIMIT,     TEXTSW_INFINITY,
	TEXTSW_BROWSING,         TRUE,
	TEXTSW_MENU,             compilermenu,
        NULL);
    xv_set(resulttext,
        WIN_CMS,                 xv_get(resultpanel, WIN_CMS),
        /*WIN_CMS,                 cms,
        WIN_BACKGROUND_COLOR,    6,
        WIN_FOREGROUND_COLOR,    7,*/
	SCROLLBAR_SPLITTABLE,    FALSE,
        NULL);
   
    results_message = xv_create(resultpanel, PANEL_MESSAGE, 
         XV_Y,                   xv_get(resulttext, XV_HEIGHT)+12,
         PANEL_LABEL_STRING,     "*** Compiling ***", 
         NULL);
    resultpanel1 = (Panel)xv_create(resultframe, PANEL,
         XV_X,                   xv_get(resulttext, XV_WIDTH)+16,
         XV_Y,                   0,
         WIN_ROWS,               2,
         XV_WIDTH,               68,
         TEXTSW_MENU,            compilermenu,
         NULL);

    prev_errbutton = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,       (Server_image)xv_create(
            (int)NULL,           SERVER_IMAGE,
            XV_WIDTH,            16,
            XV_HEIGHT,           16,
            SERVER_IMAGE_BITS,   preverr_bits,
            NULL),
        PANEL_INACTIVE,          TRUE,
        PANEL_NOTIFY_PROC,       to_prev_error,
        XV_WIDTH,                16,
        XV_HEIGHT,               16,
        NULL);
    first_errbutton = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,       (Server_image)xv_create(
            (int)NULL,           SERVER_IMAGE,
            XV_WIDTH,            16,
            XV_HEIGHT,           16,
            SERVER_IMAGE_BITS,   firsterr_bits,
            NULL),
        PANEL_INACTIVE,         TRUE,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      to_first_error,
        NULL);
    next_errbutton = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  nexterr_bits,
            NULL),
        PANEL_INACTIVE,         TRUE,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      to_next_error,
        NULL);
    last_errbutton = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  lasterr_bits,
            NULL),
        PANEL_INACTIVE,         TRUE,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      to_last_error,
        NULL);
    runXbutton2 = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  runx_bits,
            NULL),
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      RunX1,
        NULL);
    runbutton2 = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  run_bits,
            NULL),
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      Run1,
        NULL);
    compilebutton2 = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  compile_bits,
            NULL),
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      Compile1,
        NULL);
    closebutton = xv_create(resultpanel1, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  close_bits,
            NULL),
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        PANEL_NOTIFY_PROC,      exitresults,
        NULL);

    window_fit(resultpanel1);
    window_fit(resultpanel);
    xv_set(resultpanel, XV_WIDTH, xv_get(resulttext, XV_WIDTH)+16, NULL); 
    xv_set(resultpanel1, XV_HEIGHT, xv_get(resultpanel, XV_HEIGHT), NULL);     
    window_fit(resultframe);
    xv_set(resultframe, XV_SHOW, TRUE, NULL);
  }
  else
  {
    xv_set(results_message, 
           PANEL_LABEL_STRING, "*** Compiling ***", 
           NULL); 
    xv_set(resulttext, TEXTSW_BROWSING, FALSE, NULL);
    textsw_erase(resulttext, 0, (Textsw_index)xv_get (resulttext, TEXTSW_LENGTH));
  }
  errpt=0;
  textsw_set_selection(resulttext, 0, 0, SELN_PRIMARY);
  
  xv_set(resulttext, TEXTSW_FIRST, 0, NULL);
  comp_results[1] = strncpy(malloc(strlen(*childparam)+2), 
      *childparam, strlen(*childparam));
  *(comp_results[1]+strlen(*childparam)) = '\n';
  *(comp_results[1]+strlen(*childparam)+1) = '\0';
  textsw_insert(resulttext, comp_results[1], strlen(*childparam)+1);
  xv_set(resulttext, TEXTSW_BROWSING, TRUE, NULL);
  compwin_txtsize=1;
  
  /* animation */
  timer.it_value.tv_usec = 400000;
  timer.it_interval.tv_usec = 400000;
  notify_set_itimer_func(frame, animation, ITIMER_REAL, &timer, NULL);
  
  if (comp_results[0]!=NULL)
    free(comp_results[0]);           
  xv_set(closebutton, PANEL_INACTIVE, TRUE, NULL);

  xv_set(next_errbutton, PANEL_INACTIVE, TRUE, NULL);
  xv_set(first_errbutton, PANEL_INACTIVE, TRUE, NULL);  
  xv_set(prev_errbutton, PANEL_INACTIVE, TRUE, NULL);  
  xv_set(last_errbutton, PANEL_INACTIVE, TRUE, NULL);  

  if (toupper(term_disable_buf[compnum][1])=='Y')
  {
    if (button_panel!=0)
    {
      xv_set(compilebutton1, PANEL_BUSY, TRUE, NULL);
      xv_set(runbutton1, PANEL_INACTIVE, TRUE, NULL);
      xv_set(runXbutton1, PANEL_INACTIVE, TRUE, NULL);
      xv_set(savebutton, PANEL_INACTIVE, TRUE, NULL);
    }
    xv_set(compilebutton2, PANEL_BUSY, TRUE, NULL);
    xv_set(runbutton2, PANEL_INACTIVE, TRUE, NULL);
    xv_set(runXbutton2, PANEL_INACTIVE, TRUE, NULL);
  }
  compilerrunning=1;
  }
}

void 
RunX(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
RunX2();
}

void 
RunX1(item)
Panel_item   item;
{
RunX2();
}

void 
RunX2()
{
  char *callstring;
  
  if ((compilerrunning && toupper(term_disable_buf[compnum][1])=='Y')  
     || compnum==MAXCONFIGS) return;
  if ((filenamep==NULL) || !strcmp(filenamep, ""))
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO EXECUTE BECAUSE: ",
                                "-------------------------------------",
                                "             there's no              ",
                                "             file edited             ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Open file ",
        NULL);
    Filechooseropen();
    return;
  }
  if (strcmp(file_directory,working_directory))
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO EXECUTE BECAUSE: ",
                                "-------------------------------------",
                                "       directory of edited file      ",
                                "          is different from          ",
                                "          working directory          ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Change path  ",
        NULL);
    Filechooseropen();
    return;
  }
  getedittext();
  if (strlen(usew_buf[compnum])<1) return;

  callstring=malloc(
        strlen(usew_buf[compnum])+strlen(exec_buf[compnum])+4);
  sprintf(callstring, "%s%s &", usew_buf[compnum], exec_buf[compnum]);
    
  Printformat_function(callstring);
}

void 
Run(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Run2();
}

void 
Run1(item)
Panel_item   item;
{
  Run2();
}

void 
Run2()
{
  char *callstring;
  if ((compilerrunning && toupper(term_disable_buf[compnum][1])=='Y')  
     || compnum==MAXCONFIGS) return;
  if ((filenamep==NULL) || !strcmp(filenamep, ""))
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO EXECUTE BECAUSE: ",
                                "-------------------------------------",
                                "             there's no              ",
                                "             file edited             ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Open file ",
        NULL);
    Filechooseropen();
    return;
  }
  if (strcmp(file_directory,working_directory))
  {
    Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
    notice_prompt(mypanel, NULL,
        NOTICE_MESSAGE_STRINGS, " COULD NOT START TO EXECUTE BECAUSE: ",
                                "-------------------------------------",
                                "       directory of edited file      ",
                                "          is different from          ",
                                "          working directory          ",
                                "-------------------------------------",
        NULL,
        NOTICE_BUTTON_YES,      " Change path  ",
        NULL);
    Filechooseropen();
    return;
  }
  getedittext();
  if (strlen(usew_buf[compnum])<1) return;

  callstring=malloc(
        strlen(usew_buf[compnum])+strlen(exec_buf[compnum])+1);
  sprintf(callstring, "%s%s", usew_buf[compnum], exec_buf[compnum]);
    
  Printformat_function(callstring);
}

void 
Break(menu, menu_item)
Menu        menu;  
Menu_item   menu_item;
{
  Break2();
}

void 
Break1(item)
Panel_item   item;
{
  Break2();
}

void 
Break2()
{
  getedittext();
  ttysw_input (tty, "\n", 2);
  /* notify_post_destroy(client1, DESTROY_CHECKING, NOTIFY_IMMEDIATE); ???*/

  /*if (pid>0) kill(pid, SIGKILL);*/

  notify_dispatch(); /* ? */
}

void
Copyright()
{ 
  int result;
  Panel mypanel = (Panel) xv_get (panel, PANEL_PARENT_PANEL);
  result = notice_prompt(mypanel, NULL,
      NOTICE_MESSAGE_STRINGS, "      --------------------------      ",
                              "Schlampisoft",
                              "X-window-Workbench",
                              "Version 3.1",
                              "-------------------------",
                              "",
                              "(c)1996 by Michael Sohmen",
                              "See Help, About for more info",
                              "",
      NULL,
      NOTICE_BUTTON_YES,      "   Ok   ",
      NULL);
}

void 
Helpabout (menu, menu_item)       
Menu menu;
Menu_item menu_item;
{ 
  Panel mypanel;
  int exithelp();
  if (helpframe!=0)  return;
  helpframe = (Frame)xv_create ((int)NULL, FRAME, 
    FRAME_LABEL,     "Help: About this Workbench",
  NULL);
  mypanel = (Panel)xv_create(helpframe, PANEL,
       NULL);
  helptext = (Panel_item)xv_create(mypanel, PANEL_MULTILINE_TEXT,
      PANEL_DISPLAY_ROWS,         help_number_rows,
      PANEL_VALUE_DISPLAY_LENGTH, help_number_columns,
      PANEL_VALUE, help_buf[0],
  NULL);
  xv_set(mypanel, XV_SHOW, TRUE, NULL);
  (void)xv_create(mypanel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  close_bits,
            NULL),
        PANEL_NOTIFY_PROC,      exithelp,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        NULL);
  window_fit(helptext);
  window_fit(mypanel);
  window_fit(helpframe);
  xv_set(helpframe, XV_SHOW, TRUE, NULL);
}

void 
Helpquick (menu, menu_item)       
Menu menu;
Menu_item menu_item;
{
  Panel mypanel;
  int exithelp();
  if (helpframe!=0)  return;
  helpframe = (Frame)xv_create ((int)NULL, FRAME, 
    FRAME_LABEL,    "Help: Quick Introduction" ,
  NULL);
  mypanel = (Panel)xv_create(helpframe, PANEL,
       NULL);
  helptext = (Panel_item)xv_create(mypanel, PANEL_MULTILINE_TEXT,
    PANEL_DISPLAY_ROWS,         help_number_rows,
    PANEL_VALUE_DISPLAY_LENGTH, help_number_columns,
    PANEL_VALUE, help_buf[1],
  NULL);
  xv_set(mypanel, XV_SHOW, TRUE, NULL);
  xv_set(mypanel, XV_SHOW, TRUE, NULL);
  (void)xv_create(mypanel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  close_bits,
            NULL),
        PANEL_NOTIFY_PROC,      exithelp,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        NULL);
  window_fit(helptext);
  window_fit(mypanel);
  window_fit(helpframe);
  xv_set(helpframe, XV_SHOW, TRUE, NULL);
}

void 
Helpdetail (menu, menu_item)       
Menu menu;
Menu_item menu_item;
{
  Panel mypanel;
  int exithelp();
  if (helpframe!=0)  return;
  helpframe = (Frame)xv_create ((int)NULL, FRAME, 
    FRAME_LABEL,     "Help: Summary",
  NULL);
  mypanel = (Panel)xv_create(helpframe, PANEL,
       NULL);
  helptext = (Panel_item)xv_create(mypanel, PANEL_MULTILINE_TEXT,
    /*PANEL_VALUE_STORED_LENGTH,  10000,*/
    PANEL_DISPLAY_ROWS, help_number_rows,
    PANEL_VALUE_DISPLAY_LENGTH, help_number_columns,
    PANEL_VALUE, help_buf[2],
  NULL);
  xv_set(mypanel, XV_SHOW, TRUE, NULL);
  xv_set(mypanel, XV_SHOW, TRUE, NULL);
  (void)xv_create(mypanel, PANEL_BUTTON, 
        PANEL_LABEL_IMAGE,      (Server_image)xv_create(
            (int)NULL,          SERVER_IMAGE,
            XV_WIDTH,           16,
            XV_HEIGHT,          16,
            SERVER_IMAGE_BITS,  close_bits,
            NULL),
        PANEL_NOTIFY_PROC,      exithelp,
        XV_WIDTH,               16,
        XV_HEIGHT,              16,
        NULL);
  window_fit(mypanel);
  window_fit(helpframe);
  xv_set(helpframe, XV_SHOW, TRUE, NULL);
}

void 
WWW_Home (menu, menu_item)       
Menu menu;
Menu_item menu_item;
{
  char *callstring=malloc(256);
  sprintf(callstring, "netscape -remote 'openURL(http://WWW.FH-Karlsruhe.de/~somi0011/s_soft_html/s_soft.html)'");
  Printformat_function(callstring);
}

int exithelp(item, event)
Panel_item  item;
Event *event;
{
  xv_destroy_safe(helpframe);
  helpframe=0;
}

void
initcolor (cms_data, red, green, blue)
Xv_cmsdata *cms_data;
unsigned char *red, *green, *blue;
{

  static Xv_singlecolor cms_colors[] = {
        { 255, 255, 255 }, /* white      */
        { 255,   0,   0 }, /* red        */
        {   0, 255,   0 }, /* green      */
        {   0,   0, 255 }, /* blue       */
        { 255, 255,   0 }, /* yellow     */
        { 188, 143, 143 }, /* reddish    */
        { 200, 200, 200 }, /* grey       */
        {   0,   0,   0 }, /* black      */
        { 255, 128,   0 }, /* orange     */
        {   0, 128,   0 }, /* mid green  */
        { 128,   0,   0 }, /* mid red    */
        {   0,   0, 128 }, /* mid blue   */
        {  96,   0, 128 }, /* purple     */
        {   0,  64,   0 }, /* dark green */
        {  64,   0,   0 }, /* dark red   */
        {   0,   0,  64 }, /* dark blue  */
      };
      
  cms = xv_create(XV_NULL, CMS,
            CMS_SIZE,       16,
            CMS_TYPE,       XV_STATIC_CMS,
            CMS_COLORS,     cms_colors,
            NULL);
}

void config_error()
{
  printf("Some error in configuration file\n");
  printf("continuing  ...\n");
}


/* functions for reading configuration file */
int Createsetupint()
{
  int i=0;
  char xx[16000];

  while(xx[0]!='#')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while((int)xx[i]<58 && (int)xx[i]>47)
    if(fread(xx+(++i), 1, 1, fp)==0) { config_error(); return; }
  xx[i]='\0';
  return atol(xx);
}

int Createsetup2ndint()
{
  int i=0;
  char xx[16000];

  if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while((int)xx[i]<58 && (int)xx[i]>47)
    if(fread(xx+(++i), 1, 1, fp)==0) { config_error(); return; }
  xx[i]='\0';
  return atol(xx);
}

char *Createsetupstr()
{
  int i=0;
  char xx[16000];

  while(xx[0]!='#')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  i=0;
  while(xx[i]!='\0' && xx[i]!='\n')
    if(fread(xx+(++i), 1, 1, fp)==0) { config_error(); return; }
  xx[i]='\0';
  return strcpy(malloc(strlen(xx)+1), xx);
}

void
configurate(thisfile)
char *thisfile;
{  
  FILE *fp;
  char xx[16000];
  int  i,j;

  fp = open_config_file("r");

  textsw_buf_size       = Createsetupint();
  errmess_buf_size      = Createsetupint();
  textsw_proj_buf_size  = Createsetupint();
  projitems             = Createsetupint();
  horizontalsize        = Createsetupint();
  verticalsize          = Createsetup2ndint();
  projhorizontalsize    = Createsetupint();
  projverticalsize      = Createsetup2ndint();
  
  spec_font             = Createsetupstr();
  spec_font_proj        = Createsetupstr();
  text_fore_color       = 7; Createsetupint();
  text_back_color       = 0; Createsetupint();

  filech_number_rows    = Createsetupint();
  help_number_columns   = Createsetupint();
  help_number_rows      = Createsetup2ndint();
  result_number_columns = Createsetupint();
  result_number_rows    = Createsetup2ndint();
  numconfigs            = Createsetupint();

  saveconfirmation      = Createsetupstr();


  while(xx[0]!='@')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  if(fread(xx, 1, 1, fp)==0) { config_error(); return; }

  /* Reading configuration file and initialising compiler options */
  for(i=0; i<256; i++) /* i<16 before */
  {
    while(xx[0]!='{' && xx[0]!='@')
      if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
    if(xx[0]=='@') break;
    while(xx[0]!='\n')
      if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
      
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (compilername_buf[i], xx, strlen(xx)) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT*16) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (compiler_buf[i]    , xx, strlen(xx)) ;
        
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (source_buf[i]      , xx, strlen(xx) ) ;
    source_buf[i][j-1]='\0';
    
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (exec_buf[i]      , xx, strlen(xx) ) ;
      
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (usew_buf[i]      , xx, strlen(xx) ) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n' || j>=BUFFER_UNIT)
      { if(fread(xx+j, 1, 1, fp)==0) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (printer_buf[i]      , xx, strlen(xx) ) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n' || j>=BUFFER_UNIT*4)
      { if(fread(xx+j, 1, 1, fp)==0) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (printformat_buf[i]      , xx, strlen(xx) ) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT*4) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (printformat_odd_buf[i]      , xx, strlen(xx) ) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT*4) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (printformat_even_buf[i]      , xx, strlen(xx) ) ;
        
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT*4) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (preformat_print_buf[i]      , xx, strlen(xx) ) ;
        
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT*4) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (errmess_buf[i]      , xx, strlen(xx) ) ;
    
    j=0;
    while(j==0 || xx[j-1]!='\n')
      { if(fread(xx+j, 1, 1, fp)==0 || j>=BUFFER_UNIT) { config_error(); return; }  j++; }
    xx[j-1]='\0';
    strncpy (term_disable_buf[i], xx, strlen(xx) ) ;
    
    while(xx[0]!='}')
      if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  }
  /* set a no-defined file type */
 sprintf(compilername_buf[MAXCONFIGS], "File"); 
 sprintf(source_buf[MAXCONFIGS], ".."); ;
 sprintf(term_disable_buf[MAXCONFIGS], "n") ;

  while(xx[0]!='@')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
    
  /* Reading help text from configuration file */
  if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while(xx[0]!='{' && xx[0]!='@')
  {  if(xx[0]=='@') break;   if(fread(xx, 1, 1, fp)==0) { config_error(); return; }  }  
  while(xx[0]!='{')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while(xx[0]!='\n')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
    
  j=0;
  while(j==0 || xx[j-1]!='}')
    { if(fread(xx+j, 1, 1, fp)==0) { config_error(); return; }  j++; }
  xx[j-1]='\0';
  strncpy (help_buf[0], xx, strlen(xx)) ;
    
  while(xx[0]!='{' && xx[0]!='@')
  {  if(xx[0]=='@') break;   if(fread(xx, 1, 1, fp)==0) { config_error(); return; }  }
  while(xx[0]!='{')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while(xx[0]!='\n')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
    
  j=0;
  while(j==0 || xx[j-1]!='}')
    { if(fread(xx+j, 1, 1, fp)==0) { config_error(); return; }  j++; }
  xx[j-1]='\0';
  strncpy (help_buf[1], xx, strlen(xx)) ;
  
  while(xx[0]!='{' && xx[0]!='@')
  {  if(xx[0]=='@') break;   if(fread(xx, 1, 1, fp)==0) { config_error(); return; }  }
  while(xx[0]!='{')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
  while(xx[0]!='\n')
    if(fread(xx, 1, 1, fp)==0) { config_error(); return; }
    
  j=0;
  while(j==0 || xx[j-1]!='}')
    { if(fread(xx+j, 1, 1, fp)==0) { config_error(); return; }  j++; }
  xx[j-1]='\0';
  strncpy (help_buf[2], xx, strlen(xx)) ;

  fclose(fp);
}



void
canvas_repaint(canvas, pw, display, xid, xrects)
Canvas        canvas;
Xv_Window     pw;
Display      *display;
Window        xid;
Xv_xrectlist *xrects;
{ 
  if (button_panel!=0) { xv_destroy(button_panel); button_panel=0; }
  if (showbuttons)
  {
    Create_side_buttons();
    xv_set(textsw, 
         XV_X,              xv_get(button_panel, XV_WIDTH),
         XV_WIDTH,          xv_get(canvas, XV_WIDTH)-xv_get(button_panel, XV_WIDTH),
         NULL);
  }
  else
    xv_set(textsw, 
         XV_X,              0,
         XV_WIDTH,          xv_get(canvas, XV_WIDTH),
         NULL);

  if (showtty)
  {
    xv_set(tty, XV_SHOW, TRUE, NULL);
    xv_set(textsw, XV_HEIGHT, (xv_get(canvas, XV_HEIGHT)/5)*4, NULL);
  }
  else
  {
    xv_set(tty, XV_SHOW, FALSE, NULL);
    if (button_panel!=0) 
      xv_set(button_panel, XV_HEIGHT, xv_get(canvas, XV_HEIGHT), NULL);
    xv_set(textsw, XV_HEIGHT, xv_get(canvas, XV_HEIGHT), NULL);
  }
    
  if (piccanvas!=0) { xv_destroy(piccanvas); piccanvas=0; }
  
  if (showtty)
  {
    piccanvas = (Canvas) xv_create (canvas, CANVAS,
         CANVAS_REPAINT_PROC,   piccanvas_repaint,
         CANVAS_X_PAINT_WINDOW, TRUE,
         WIN_DYNAMIC_VISUAL,    FALSE,
         XV_X,                   0,
         WIN_BELOW,              textsw,
         XV_WIDTH,          (215*xv_get(canvas, XV_HEIGHT))/700,
         XV_HEIGHT,         xv_get(canvas, XV_HEIGHT)-xv_get(textsw, XV_HEIGHT),
         WIN_CMS,           cms,
         NULL);
    xv_set(tty,
         XV_X,              xv_get(piccanvas, XV_WIDTH),
         WIN_BELOW,         textsw,
         XV_WIDTH,          xv_get(canvas, XV_WIDTH)-xv_get(piccanvas, XV_WIDTH), 
         XV_HEIGHT,         xv_get(canvas, XV_HEIGHT)-xv_get(textsw, XV_HEIGHT),
         NULL);
  }
}

void
piccanvas_repaint(canvas, pw, display, xid, xrects)
Canvas        canvas;
Xv_Window     pw;
Display      *display;
Window        xid;
Xv_xrectlist *xrects;
{
  float m = (float) (xv_get(canvas, XV_WIDTH)-50) / 170. ;
  XSetForeground(display, gc, colors[text_back_color]);
  XFillRectangle(display, xid, gc, 0, 0, xv_get(piccanvas, XV_WIDTH), xv_get(piccanvas, XV_HEIGHT));
  XSetForeground(display, gc, colors[10]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(15.*m), (int)(425.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[8]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(20.*m), (int)(400.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[4]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(25.*m), (int)(375.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[2]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(30.*m), (int)(350.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[9]);/* ++ */
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(35.*m), (int)(325.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[3]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(40.*m), (int)(300.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[11]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(45.*m), (int)(275.*m), (int)(140.*m), 5750, 3833);
  XSetForeground(display, gc, colors[15]);
  XFillArc(display, xid, gc, (int)(-10.*m), (int)(50.*m), (int)(250.*m), (int)(140.*m), 5750, 3833);
  XFillRectangle(display, xid, gc, (int)(8.*m), (int)(80.*m), (int)(111.*m), (int)(52.*m));
  XSetForeground(display, gc, colors[4]);
  XDrawString(display, xid, gc, (int)(7.*m), (int)(95.*m), "  Schlampisoft", 14);
  XDrawString(display, xid, gc, (int)(10.*m), (int)(110.*m), "   X-window", 11);
  XDrawString(display, xid, gc, (int)(7.*m), (int)(125.*m), "   Workbench", 12);
  XSetForeground(display, gc, colors[0]);
  XFillArc(display, xid, gc, (int)(114.*m), (int)(20.*m), (int)(60.*m), (int)(40.*m), 0, 17300);
  XFillArc(display, xid, gc, (int)(114.*m), (int)(50.*m), (int)(60.*m), (int)(40.*m), 11550, 17300);
  XSetForeground(display, gc, colors[7]);
  XFillArc(display, xid, gc, (int)(116.*m), (int)(22.*m), (int)(58.*m), (int)(38.*m), 0, 17300);
  XFillArc(display, xid, gc, (int)(116.*m), (int)(52.*m), (int)(58.*m), (int)(38.*m), 11550, 17300);
  XSetForeground(display, gc, colors[0]);
  XFillArc(display, xid, gc, (int)(129.*m), (int)(30.*m), (int)(32.*m), (int)(22.*m), 0, 23500);
  XFillArc(display, xid, gc, (int)(129.*m), (int)(60.*m), (int)(32.*m), (int)(22.*m), 0, 23500);
  XSetForeground(display, gc, colors[2]);
  XFillArc(display, xid, gc, (int)(117.*m), (int)(24.*m), (int)(45.*m), (int)(30.*m), 19650, 3250);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(30.*m), (int)(30.*m), (int)(20.*m), 0, 23500);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(60.*m), (int)(30.*m), (int)(20.*m), 0, 23500);
  XSetForeground(display, gc, colors[9]);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(30.*m), (int)(30.*m), (int)(20.*m), 10000, 9800);
  XSetForeground(display, gc, colors[3]);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(30.*m), (int)(30.*m), (int)(20.*m), 11200, 5150);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(60.*m), (int)(30.*m), (int)(20.*m), 6300, 10200);
  XSetForeground(display, gc, colors[9]);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(60.*m), (int)(30.*m), (int)(20.*m), 16300, 3600);
  XFillArc(display, xid, gc, (int)(128.*m), (int)(60.*m), (int)(30.*m), (int)(20.*m), 2800, 2800);
  XFillRectangle(display, xid, gc, (int)(131.*m), (int)(36.*m), (int)(20.*m), (int)(5.*m));
  XFillRectangle(display, xid, gc, (int)(140.*m), (int)(36.*m), (int)(12.*m), (int)(13.*m));
  XFillRectangle(display, xid, gc, (int)(148.*m), (int)(36.*m), (int)(4.*m), (int)(14.*m));
  XFillRectangle(display, xid, gc, (int)(141.*m), (int)(61.*m), (int)(4.*m), (int)(18.*m));
  XFillRectangle(display, xid, gc, (int)(143.*m), (int)(65.*m), (int)(10.*m), (int)(12.*m));
}


void
initchips(panel, chips)
Panel panel;
Server_image chips[];
{
  register int i;
  Display *dpy = (Display *)xv_get (panel, XV_DISPLAY);
  unsigned long mask, *pixels;
  XGCValues values;
  Pixmap pixmap;

  if (DefaultDepth(dpy, DefaultScreen(dpy)) == 1)
  {
    ttysw_output(tty, "Editor colors disabled in two-color mode\n" , 42);
  }  
  else
  {
    values.graphics_exposures = FALSE ;
    values.foreground = 1 ;
    mask = GCGraphicsExposures | GCForeground ;
    gc = XCreateGC(dpy,
         RootWindow(dpy, DefaultScreen(dpy)), mask, &values);

    pixels = (unsigned long *)xv_get (panel, WIN_X_COLOR_INDICES);
    for(i=0; i<NUM_COLORS; i++)
    {
      chips[i] = (Server_image)xv_create (XV_NULL, SERVER_IMAGE,
                  SERVER_IMAGE_COLORMAP, "palette",
      XV_WIDTH,           16,
      XV_HEIGHT,          16,
      SERVER_IMAGE_DEPTH,  8,
      NULL);
    XSetForeground(dpy, gc, pixels[i]);
    pixmap = (Pixmap)xv_get (chips[i], XV_XID);
    XFillRectangle(dpy, pixmap, gc, 0, 0, 16, 16);
    }
  }   
}



void 
choosecolor (menu, menu_item)       
Menu menu;
Menu_item menu_item;
{
  int i;
  Frame myframe ;
  Panel mypanel ;
  myframe = (Frame)xv_create ((int)NULL, FRAME,
        XV_WIDTH,       120,
        XV_HEIGHT,       80, 
        FRAME_LABEL,    "SELECT A COLOR:",
        NULL);
  mypanel = (Panel)xv_create (myframe, PANEL,
        PANEL_LAYOUT,   PANEL_VERTICAL,
         WIN_CMS,       cms,
        XV_WIDTH,       120,
        XV_HEIGHT,       80,
        NULL);
}

